/*
###########################################################################
#                                                                         #
# File   :	leiste.cpp                                                #
# Project:	PP                                                        #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include "leiste.h"

  leiste::leiste(QWidget *parent=0, const char *name=0,
                 QString picPfad="")
         :QWidget (parent, name)
  {
    sci=0;
    setMouseTracking (TRUE);

    energieLabel1=new QLabel (this,"energieLabel1");
    energieLabel1->setAlignment(AlignCenter);
    energieLabel1->setLineWidth (1);
    energieLabel1->setText("Stored Energie:");
    energieLabel2=new QLabel (this,"energieLabel2");
    energieLabel2->setAlignment(AlignCenter);
    energieLabel2->setFrameStyle(QFrame::Box|QFrame::Raised);
    energieLabel2->setLineWidth (1);
    energieLabel2->setText("0");

    energieLabel3=new QLabel (this,"energieLabel1");
    energieLabel3->setAlignment(AlignCenter);
    energieLabel3->setLineWidth (1);
    energieLabel3->setText("Produced Energie:");
    energieLabel4=new QLabel (this,"energieLabel2");
    energieLabel4->setAlignment(AlignCenter);
    energieLabel4->setFrameStyle(QFrame::Box|QFrame::Raised);
    energieLabel4->setLineWidth (1);
    energieLabel4->setText("0");

    energieLabel5=new QLabel (this,"energieLabel1");
    energieLabel5->setAlignment(AlignCenter);
    energieLabel5->setLineWidth (1);
    energieLabel5->setText("Used Energie:");
    energieLabel6=new QLabel (this,"energieLabel2");
    energieLabel6->setAlignment(AlignCenter);
    energieLabel6->setFrameStyle(QFrame::Box|QFrame::Raised);
    energieLabel6->setLineWidth (1);
    energieLabel6->setText("0");

    controlLabel1=new QLabel (this,"energieLabel1");
    controlLabel1->setAlignment(AlignCenter);
    controlLabel1->setLineWidth (1);
    controlLabel1->setText("Controlers");
    controlLabel2=new QLabel (this,"energieLabel2");
    controlLabel2->setAlignment(AlignCenter);
    controlLabel2->setFrameStyle(QFrame::Box|QFrame::Raised);
    controlLabel2->setLineWidth (1);
    controlLabel2->setText("0");

    controlLabel3=new QLabel (this,"energieLabel1");
    controlLabel3->setAlignment(AlignCenter);
    controlLabel3->setLineWidth (1);
    controlLabel3->setText("Controled Vihecels");
    controlLabel4=new QLabel (this,"energieLabel2");
    controlLabel4->setAlignment(AlignCenter);
    controlLabel4->setFrameStyle(QFrame::Box|QFrame::Raised);
    controlLabel4->setLineWidth (1);
    controlLabel4->setText("0");

    xBuildings=250;
    xCars=250;
    xEnergie=250;

    energieLabel1->setGeometry
       (-xEnergie, 25*0, buttonBreite, 25);
    energieLabel2->setGeometry
       (-xEnergie, 25*1, buttonBreite, 25);
    energieLabel3->setGeometry
       (-xEnergie, 25*2, buttonBreite, 25);
    energieLabel4->setGeometry
       (-xEnergie, 25*3, buttonBreite, 25);
    energieLabel5->setGeometry
       (-xEnergie, 25*4, buttonBreite, 25);
    energieLabel6->setGeometry
       (-xEnergie, 25*5, buttonBreite, 25);
    controlLabel1->setGeometry
       (-xSteuer, 25*0, buttonBreite, 25);
    controlLabel2->setGeometry
       (-xSteuer, 25*1, buttonBreite, 25);
    controlLabel3->setGeometry
       (-xSteuer, 25*2, buttonBreite, 25);
    controlLabel4->setGeometry
       (-xSteuer, 25*3, buttonBreite, 25);

    zentrale = new QPushButton( "Zentrale", this, "zentrale" );
    zentrale->setFont( QFont( "Times", 18, QFont::Bold ) );
    zentrale->setGeometry(0, 0, buttonBreite, buttonHoehe);
    picZentrale.load(picPfad+"/piczen2.gif");
    zentrale->setPixmap (picZentrale);
    connect (zentrale, SIGNAL (clicked()),
             this, SLOT (buildZentraleButton()));
    carProd = new QPushButton( "carProd", this, "carProd" );
    carProd->setText( "carProd" );
    carProd->setFont( QFont( "Times", 18, QFont::Bold ) );
    carProd->setGeometry(0, buttonHoehe, buttonBreite, buttonHoehe);

    QString zwString=picPfad+"/piccarprod.gif";
    const char *pfad2=zwString;
    picCarProd.load(pfad2);
    carProd->setPixmap (picCarProd);
    connect (carProd, SIGNAL (clicked()),
             this, SLOT (buildCarprodButton()));
    energieButton = new QPushButton( "Energie", this, "Energie" );
    energieButton->setFont( QFont( "Times", 18, QFont::Bold ) );
    energieButton->setGeometry(0, buttonHoehe*2, buttonBreite, buttonHoehe);
    picEnergie.load(picPfad+"/picenergie.gif");
    energieButton->setPixmap (picEnergie);
    connect (energieButton, SIGNAL (clicked()),
             this, SLOT (buildEnergieButton()));

    cannonButton = new QPushButton( "cannon", this, "cannon" );
    cannonButton->setFont( QFont( "Times", 18, QFont::Bold ) );
    cannonButton->setGeometry(0, buttonHoehe*3, buttonBreite, buttonHoehe);
    picCannon.load(picPfad+"/piccannon.gif");
    cannonButton->setPixmap (picCannon);
    connect (cannonButton, SIGNAL (clicked()),
             this, SLOT (buildCannonButton()));

    cannon2Button = new QPushButton( "cannon2", this, "cannon2" );
    cannon2Button->setGeometry(-250, buttonHoehe*6, buttonBreite,
                               buttonHoehe);    
    picCannon2.load(picPfad+"/piccan2.gif");
    cannon2Button->setPixmap (picCannon2);
    connect (cannon2Button, SIGNAL (clicked()),
             this, SLOT (buildCannon2Button()));

    sciButton = new QPushButton( "sci", this, "sci" );
    sciButton->setGeometry(0, buttonHoehe*4, buttonBreite, buttonHoehe);
    picSci.load(picPfad+"/picsci.gif");
    sciButton->setPixmap (picSci);
    connect (sciButton, SIGNAL (clicked()),
             this, SLOT (buildSciButton()));

    radarButton = new QPushButton( "radar", this, "radar" );
    radarButton->setGeometry(-250, buttonHoehe*7, buttonBreite, buttonHoehe);

    picRadar.load(picPfad+"/picradar.gif");
    radarButton->setPixmap (picRadar);
    connect (radarButton, SIGNAL (clicked()),
             this, SLOT (buildRadarButton()));

    energie2Button = new QPushButton( "energie2", this, "energie2" );
    energie2Button->setGeometry(-250, buttonHoehe*8, buttonBreite,
                                buttonHoehe); 
    
    picEnergie2.load(picPfad+"/picen2.gif");;
    energie2Button->setPixmap (picEnergie2);
    connect (energie2Button, SIGNAL (clicked()),
             this, SLOT (buildEnergie2Button()));

    steuerButton = new QPushButton( "steuer", this, "steuer" );
    steuerButton->setGeometry(-0, buttonHoehe*5, buttonBreite, buttonHoehe);
    picSteuer.load(picPfad+"/picsteuer.gif");
    steuerButton->setPixmap (picSteuer);
    connect (steuerButton, SIGNAL (clicked()),
             this, SLOT (buildSteuerButton()));

    jeepButton = new QPushButton( "Jeep", this, "jeep" );
    jeepButton->setFont( QFont( "Times", 18, QFont::Bold ) );
    jeepButton->setGeometry(-250, 0, buttonBreite, buttonHoehe);
    picPan1.load(picPfad+"/picpan1.gif");
    jeepButton->setPixmap (picPan1);
    connect (jeepButton, SIGNAL (clicked()),
             this, SLOT (buildPan1Button()));
    panzerButton = new QPushButton( "Panzer", this, "panzerButton" );
    panzerButton->setFont( QFont( "Times", 18, QFont::Bold ) );
    panzerButton->setGeometry(-250, buttonHoehe, buttonBreite, buttonHoehe);
    picPan2.load(picPfad+"/picpan2.gif");
    panzerButton->setPixmap (picPan2);
    connect (panzerButton, SIGNAL (clicked()),
             this, SLOT (buildPan2Button()));
    panzerButton2 = new QPushButton( "Panzer", this, "panzerButton" );
    panzerButton2->setFont( QFont( "Times", 18, QFont::Bold ) );
    panzerButton2->setGeometry(-250, buttonHoehe*2, buttonBreite,
             buttonHoehe);
    picPan3.load(picPfad+"/picpan3.gif");
    panzerButton2->setPixmap (picPan3);
    connect (panzerButton2, SIGNAL (clicked()),
             this, SLOT (buildPan3Button()));
    panzerButton3 = new QPushButton( "Panzer", this, "panzerButton" );
    panzerButton3->setFont( QFont( "Times", 18, QFont::Bold ) );
    panzerButton3->setGeometry(-250, buttonHoehe*3, buttonBreite, buttonHoehe);
    picPan4.load(picPfad+"/picpan4.gif");
    panzerButton3->setPixmap (picPan4);
    connect (panzerButton3, SIGNAL (clicked()),
             this, SLOT (buildPan4Button()));

      zentrale->setGeometry
       (-xBuildings, buttonY, buttonBreite,buttonHoehe);
      carProd->setGeometry
       (-xBuildings, buttonHoehe+buttonY, buttonBreite,buttonHoehe);
      energieButton->setGeometry
       (-xBuildings,buttonHoehe*2+buttonY, buttonBreite, buttonHoehe);
      cannonButton->setGeometry
       (-xBuildings, buttonHoehe*3+buttonY, buttonBreite, buttonHoehe);
      sciButton->setGeometry
       (-xBuildings, buttonHoehe*4+buttonY, buttonBreite, buttonHoehe);
      steuerButton->setGeometry
       (-xBuildings, buttonHoehe*5+buttonY, buttonBreite, buttonHoehe);
      cannon2Button->setGeometry
       (-xBuildings, buttonHoehe*6+buttonY, buttonBreite, buttonHoehe);
      radarButton->setGeometry
       (-xBuildings, buttonHoehe*7+buttonY, buttonBreite, buttonHoehe);
      energie2Button->setGeometry
       (-xBuildings, buttonHoehe*8+buttonY, buttonBreite, buttonHoehe);

    xCars=150;
    xBuildings=0;
    buttonY=0;
  }

void leiste::changeLeisteSlot (QString name)
  {
    if (name=="sci1")
      {sci=1;}
    if (name=="Zentrale1")
    {
      xCars=250;
      xBuildings=0;
      sci=0;
      xEnergie=250;
      xSteuer=250;
    }
    else if (name=="carProd1")
    {
      xCars=0;
      xBuildings=250;
      sci=0;
      xEnergie=250;
      xSteuer=250;
    }
    if (name=="Zentrale2")
    {
      xCars=250;
      xBuildings=0;
      sci=1;
      xEnergie=250;
      xSteuer=250;
    }
    else if (name=="carProd2")
    {
      xCars=0;
      xBuildings=250;
      sci=1;
      xEnergie=250;
      xSteuer=250;
    }
    else if (name=="none")
    {
      xCars=250;
      xBuildings=250;
      xEnergie=250;
      xSteuer=250;
    }
    else if (name=="Energie")
    {
      xCars=250;
      xBuildings=250;
      xEnergie=0;
      xSteuer=250;
    }
    else if (name=="Steuer")
    {
      xCars=250;
      xBuildings=250;
      xEnergie=250;
      xSteuer=0;
    }
    setzeLeiste();
  }

void leiste::mouseMoveEvent (QMouseEvent *event)
{
  if (xCars==0)
  {
    if ((event->y()>=buttonHoehe*0+buttonY)
        &&(event->y()<=buttonHoehe*1+buttonY))
      {emit changeDesc ("SCT (Standard Combat Tank):                         Energie: 700/-1 ");}

    else if ((event->y()>buttonHoehe*1+buttonY)
        &&(event->y()<=buttonHoehe*2+buttonY))
      {emit changeDesc ("Spy: fast Movement, but also weak:                  Energie: 600/-1");}

    else if ((event->y()>buttonHoehe*2+buttonY)&&(sci==1)
        &&(event->y()<=buttonHoehe*3+buttonY))
    {emit changeDesc ("Wolf: fast movement, week fast attacks:               Energie: 500/-1");}
    else if ((event->y()>buttonHoehe*3+buttonY)&&(sci==1)
        &&(event->y()<=buttonHoehe*4+buttonY))
      {emit changeDesc ("Destructor, slow movement, but very strong attacks: Energie: 1700/-2");}
  }
  else if (xBuildings==0)
  {
    if ((event->y()>=buttonHoehe*0+buttonY)
        &&(event->y()<=buttonHoehe*1+buttonY))
      {emit changeDesc ("House Construction Unit:                  Energie: 6000/-5");}
       else if ((event->y()>buttonHoehe*1+buttonY)
        &&(event->y()<=buttonHoehe*2+buttonY))
      {emit changeDesc ("Car Construction Unit:                    Energie: 4000/-5");}

    else if ((event->y()>buttonHoehe*2+buttonY)
        &&(event->y()<=buttonHoehe*3+buttonY))
      {emit changeDesc ("Energie Supplier(+5)                      Energie: 2000/+5");}

    else if ((event->y()>buttonHoehe*3+buttonY)
        &&(event->y()<=buttonHoehe*4+buttonY))
      {emit changeDesc ("Defender: fast weak attacks on viehecels: Energie: 2000/-3");}

    else if ((event->y()>buttonHoehe*4+buttonY)
        &&(event->y()<=buttonHoehe*5+buttonY))
      {emit changeDesc ("Research Lab:                             Energie: 20000/-20");}
    else if ((event->y()>buttonHoehe*5+buttonY)
        &&(event->y()<=buttonHoehe*6+buttonY))
      {emit changeDesc ("Controler:                                Energie: 1500/-1");}
    else if ((event->y()>buttonHoehe*6+buttonY)&&(sci==1)
        &&(event->y()<=buttonHoehe*7+buttonY))
      {emit changeDesc ("Destroier: strong attacks on viehecels:   Energie: 3500/-5");}
    else if ((event->y()>buttonHoehe*7+buttonY)&&(sci==1)
        &&(event->y()<=buttonHoehe*8+buttonY))
      {emit changeDesc ("Investigator (Radar):                     Energie: 2500/-10");}
    else if ((event->y()>buttonHoehe*8+buttonY)&&(sci==1)
        &&(event->y()<=buttonHoehe*9+buttonY))
      {emit changeDesc ("Fusionsenergie(+30):                      Energie: 10000/+30");}   
  }
}

void leiste::setzeLeiste()
  {
   // emit changeDesc ("test");
      jeepButton->setGeometry
       (-xCars, buttonY, buttonBreite, buttonHoehe);
      panzerButton2->setGeometry
       (-xCars, buttonHoehe+buttonY, buttonBreite, buttonHoehe);
      if (sci==1)
      {
        panzerButton->setGeometry
         (-xCars, buttonHoehe*2+buttonY, buttonBreite,buttonHoehe);
        panzerButton3->setGeometry
         (-xCars, buttonHoehe*3+buttonY, buttonBreite,buttonHoehe);
      }
      else
      {
        panzerButton->setGeometry
         (-250, buttonHoehe*2+buttonY, buttonBreite,buttonHoehe);
        panzerButton3->setGeometry
         (-250, buttonHoehe*3+buttonY, buttonBreite,buttonHoehe);
      }
      zentrale->setGeometry
       (-xBuildings, buttonY, buttonBreite,buttonHoehe);
      carProd->setGeometry
       (-xBuildings, buttonHoehe+buttonY, buttonBreite,buttonHoehe);
      energieButton->setGeometry
       (-xBuildings,buttonHoehe*2+buttonY, buttonBreite, buttonHoehe);
      cannonButton->setGeometry
       (-xBuildings, buttonHoehe*3+buttonY, buttonBreite, buttonHoehe);
      sciButton->setGeometry
       (-xBuildings, buttonHoehe*4+buttonY, buttonBreite, buttonHoehe);
      steuerButton->setGeometry
       (-xBuildings, buttonHoehe*5+buttonY, buttonBreite, buttonHoehe);
      if (sci==1)
      {
        cannon2Button->setGeometry
         (-xBuildings, buttonHoehe*6+buttonY, buttonBreite, buttonHoehe);
        radarButton->setGeometry
         (-xBuildings, buttonHoehe*7+buttonY, buttonBreite, buttonHoehe);
        energie2Button->setGeometry
         (-xBuildings, buttonHoehe*8+buttonY, buttonBreite, buttonHoehe);
      }
      else
      {
        cannon2Button->setGeometry
         (-250, buttonHoehe*6+buttonY, buttonBreite, buttonHoehe);
        radarButton->setGeometry
         (-250, buttonHoehe*7+buttonY, buttonBreite, buttonHoehe);
        energie2Button->setGeometry
         (-250, buttonHoehe*8+buttonY, buttonBreite, buttonHoehe);
      }
      energieLabel1->setGeometry
         (-xEnergie, 25*0, buttonBreite, 25);
      energieLabel2->setGeometry
         (-xEnergie, 25*1, buttonBreite, 25);
      energieLabel3->setGeometry
         (-xEnergie, 25*2, buttonBreite, 25);
      energieLabel4->setGeometry
         (-xEnergie, 25*3, buttonBreite, 25);
      energieLabel5->setGeometry
         (-xEnergie, 25*4, buttonBreite, 25);
      energieLabel6->setGeometry
         (-xEnergie, 25*5, buttonBreite, 25);
      controlLabel1->setGeometry
         (-xSteuer, 25*0, buttonBreite, 25);
      controlLabel2->setGeometry
         (-xSteuer, 25*1, buttonBreite, 25);
      controlLabel3->setGeometry
         (-xSteuer, 25*2, buttonBreite, 25);
      controlLabel4->setGeometry
         (-xSteuer, 25*3, buttonBreite, 25);
  }

void leiste::scrollButtonsV(int y)
  {
    buttonY=-y*buttonHoehe;
    setzeLeiste();
  }

void leiste::buildCarprodButton ()
  {
    emit buildCarprodButtonTransmitter ();
  }

void leiste::buildZentraleButton ()
  {
    emit buildZentraleButtonTransmitter ();
  }

void leiste::buildPan1Button ()
  {
    emit buildPan1ButtonTransmitter ();
  }

void leiste::buildPan2Button ()
  {
    emit buildPan2ButtonTransmitter ();
  }

void leiste::buildPan3Button ()
  {
    emit buildPan3ButtonTransmitter ();
  }

void leiste::buildPan4Button ()
  {
    emit buildPan4ButtonTransmitter ();
  }

void leiste::buildEnergieButton ()
  {
    emit buildEnergieButtonTransmitter ();
  }

void leiste::buildCannonButton ()
  {
    emit buildCannonButtonTransmitter ();
  }

void leiste::buildCannon2Button ()
  {
    emit buildCannon2ButtonTransmitter ();
  }

void leiste::buildSciButton ()
  {
    emit buildSciButtonTransmitter ();
  }

void leiste::buildRadarButton ()
  {
    emit buildRadarButtonTransmitter ();
  }

void leiste::buildSteuerButton ()
  {
    emit buildSteuerButtonTransmitter ();
  }

void leiste::buildEnergie2Button ()
  {
    emit buildEnergie2ButtonTransmitter ();
  }
