/*
###########################################################################
#                                                                         #
# File   :	leiste.h                                                  #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include <qpushbt.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qlabel.h>

#ifndef LEISTE_H
#define LEISTE_H

class leiste : public QWidget {

const int buttonHoehe=104, buttonBreite=140;
//const QString picPfad2="./pic";

Q_OBJECT

    public:
       leiste (QWidget *parent=0, const char *name=0,
               QString picPfad="");
       void setzeLeiste();
       void mouseMoveEvent (QMouseEvent *event);
       QPushButton *quit;
       QPushButton *zentrale, *panzerButton,*panzerButton2;
       QPushButton *panzerButton3, *cannonButton, *sciButton;
       QPushButton *radarButton, *cannon2Button;
       QPushButton *steuerButton, *energie2Button;
       QPushButton *carProd, *jeepButton, *energieButton;
       QPixmap picZentrale, picEnergie, picCarProd;
       QPixmap picRadar, picSci, picCannon2;
       QPixmap picSteuer, picEnergie2;
       QPixmap picPan1, picPan2, picPan3, picPan4, picCannon;
       QLabel *energieLabel1, *energieLabel2, *energieLabel3, *energieLabel4;
       QLabel *energieLabel5, *energieLabel6, *controlLabel1, *controlLabel2;
       QLabel *controlLabel3, *controlLabel4;
       int buttonY, xBuildings, xCars, sci, xSteuer, xEnergie;

public slots:
  void changeLeisteSlot (QString name);
  void buildCarprodButton ();
  void buildZentraleButton ();
  void buildPan1Button ();
  void buildPan2Button ();
  void buildPan3Button ();
  void buildPan4Button ();
  void buildEnergieButton ();
  void buildCannonButton ();
  void buildCannon2Button ();
  void buildSciButton ();
  void buildRadarButton ();
  void buildEnergie2Button ();
  void buildSteuerButton ();
  void scrollButtonsV(int x);

signals:
  void buildCarprodButtonTransmitter();
  void buildEnergieButtonTransmitter();
  void buildCannonButtonTransmitter();
  void buildPan1ButtonTransmitter();
  void buildPan2ButtonTransmitter();
  void buildPan3ButtonTransmitter();
  void buildPan4ButtonTransmitter();
  void buildZentraleButtonTransmitter();
  void buildSciButtonTransmitter();
  void buildCannon2ButtonTransmitter();
  void buildRadarButtonTransmitter();
  void buildEnergie2ButtonTransmitter();
  void buildSteuerButtonTransmitter();
  void changeDesc(const char*);
};

#endif
