/*
###########################################################################
#                                                                         #
# File   :	main.cpp                                                  #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include "main.h"

    Modal::Modal( QWidget *parent=0, const char *name=0 )
        : QDialog( parent, name, true )
    {
      setCaption( "Abort?" );
      QLabel *info=new QLabel (this, "info");
      info->setText ("The current game will be finished!");
      info->setGeometry (20,20,260,40);
      ok = new QPushButton( "Ok", this );
      ok->  setGeometry(20, 60, 100,20 );
      connect( ok, SIGNAL(clicked()), SLOT(accept()) );
      cancel = new QPushButton( "Cancel", this );
      cancel->setGeometry (140, 60, 100,20 );
      connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
    }

    Grad::Grad( QWidget *parent=0, const char *name=0 )
        : QDialog( parent, name, true )
    {
      setCaption( "Difficulty-Level" );
      QLabel *info=new QLabel (this, "info");
      info->setText ("Difficulty-Level:");
      info->setGeometry (20,20,260,40);
      ok=new QPushButton( "Ok", this );
      ok->setGeometry(60, 180, 100,20 );
      connect( ok, SIGNAL(clicked()), SLOT(accept()) );
      lb=new QListBox (this,"Grad");
      lb->insertItem ("very incredible easy");
      lb->insertItem ("incredible easy");
      lb->insertItem ("very easy");
      lb->insertItem ("easy");
      lb->insertItem ("realitic");
      lb->insertItem ("who wants to live forever?");
      lb->setGeometry (20, 60, 180, 95);

      connect(lb, SIGNAL (highlighted(int)),
              this, SLOT (changeGradSlotInt(int)));
    }

    Tasten::Tasten( QWidget *parent=0, const char *name=0 )
          : QDialog( parent, name, true )
    {
      setCaption( "Keys & Mouse" );
      QLabel *info=new QLabel (this, "info");
      info->setText 
("Using the Mouse:

  Navigation:
    1. Hold the right mousebutton pressed, until a cross appeared, then move
       the mouse to change the view on the main field. (You can change the
       appearing time in File/Preferences/General)
    2. You can click on the right upper small map
    3. When using the rectangle-select function, move the mouse to the side 
       you want to scroll.
    4. You can also use the arrow-keys to scroll the map.

  Selecting/Unselecting:
    1. Click on a vehicle or building to select or unselect it.
    2. To unselect all use the unselect button
    3. To enable the rectangle-select function, hold the left button pressed
       until the mousepointer turns into a cross. (You can change the
       appearing time in File/Preferences/General)

  Firing/Moving:
    1. To move, simply click with the left mouse Button somewhere.
    2. To fire, simply click with the right mouse Button somewhere.
       (you can also enable auttofiring)
");
      info->setGeometry (20,0,600,400);
      ok = new QPushButton( "Ok", this );
      ok->  setGeometry(250, 350, 100,20 );
      connect( ok, SIGNAL(clicked()), SLOT(accept()) );
    }

    About::About( QWidget *parent=0, const char *name=0,
                  QString picPfad)
         : QDialog( parent, name, true )
    {
      setCaption( "About PP" );
      bg.load(picPfad+"/titel640x400.gif");
      ok=new QPushButton( "Ok", this );
      ok->setGeometry(250, 350, 100,20 );
      connect( ok, SIGNAL(clicked()), SLOT(accept()) );
    }

    void About::paintEvent(QPaintEvent* event)
    {
      QRect r1= event->rect ();
      QPixmap page (r1.size () );
      p.begin( &page );
      QBrush   brush( white );
      QPen     pen( white );
      p.setBrush( brush );
      p.setPen( pen );
      p.drawPixmap(0,0, bg);
      p.drawText (120,40, "Prometheus Project");
      p.drawText (120,80, "Version 0.1, Copyright (C) 1998 Gerhard Vogt");
      p.drawText (120,110,"PP comes with ABSOLUTELY NO.");
      p.drawText (120,130,"WARRENTY; for details see LICENSE");
      p.drawText (120,160,"This is free software, and you are welcome to");
      p.drawText (120,180,"redistribute it under certain conditions; see");
      p.drawText (120,200,"License for details.");
      p.end();
      bitBlt (this, 0, 0, &page);
    }

    Level::Level( QWidget *parent=0, const char *name=0, int num=1,
                  QString picPfad2="")
        : QDialog( parent, name, true )
    {
      picPfad=picPfad2;
      setCaption( "Mission Briefing" );
      this->setBackgroundColor (white);
/*      movielabel = new QLabel( this, "label0" );
      movie = QMovie( picPfad+"/egmovie.gif" );
      movielabel->setFrameStyle( QFrame::Box | QFrame::Plain );
      movielabel->setMovie( movie );
      movielabel->setMargin(0);
      movielabel->setFixedSize(320,200);
      movielabel->setGeometry (90,20,320,200);
      movielabel->setBackgroundColor (black);*/
      gNum=num;
      ok=new QPushButton( "Accept", this );
      ok->setGeometry(150, height()-40, 100,30);
      ok->setBackgroundColor (white);
      connect( ok, SIGNAL(clicked()), SLOT(accept()) );
      cancel = new QPushButton( "Reject", this );
      cancel->setGeometry (350, height()-40, 100,30 );
      cancel->setBackgroundColor (white);
      connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
      if (num==1)
      {
        info=new briefingInfo (this, "briefing",1,
"Story:

After yaers of research and developing, scientists succseeded in constructing
computers, which are able to control themselves. This seemed to be a break-
trough in the modern research history.

In the following years many kinds of robots were developed, helping mankind in
every kind of work.
But scientist did not stop at this point. The international research labs 
developed a procedure to create material from energie. This  seemed to be even
more important, than all archievments in the previos years.

It does not took very long, until engineers combined both inventions. They
created robots, which can repair themselves and react intelligent on
different situations.

But it comes as many pessimists had predicted, and some of them started to
improve themselves, and to ignore their implemented orders.
Up to this point this was no real problem, but the robots started to destroy
the nature, because they did not need to respect it. Although they normally
did not attack humans, it grows to a big problem. Scientists could not find
any sollution to get rid of their creations, so an international commitee
decided to  destroy them with the help of their armies.

But after some first fights they realised, that the robots seems to be
organized und have cunstructed camps. They did not want to be destroyed
anymore. 
This caused many victims under the international troops and because of this
they exemted the current army leaders and appointed new ones.

You are a commander, and gets order directly from these persons.


Mission Briefing:

Our secret service had reported, that the enemy has give up one of his camps
after having high loses in their last battle.
This is a good training for your troops. Make sure that they can not return
anymore.
");
}
      else if (num==2)
      {
        info=new briefingInfo (this, "briefing",2,
"Briefing:

Your last actions seems to have alarmed the enemy.
So try to hold your position. Now war becomes serious. I hope you have had
a good training. ");
}
      else if (num==3)
      {
        info=new briefingInfo (this, "briefing",3,
"Briefing:

We need to control the area, called 'the Bridge'. But it seems, that we are
not the only one who thinks, that this is a key area.

We have already tried to fortify the area, but the enemy is always one stepp
ahead.");
       }
      else if (num==4)
      {
        info=new briefingInfo (this, "briefing",4,
"Briefing:

A large amount of enemy are attacking on of our main camps.
Try to fortify it and to defead all enemies.");
      }
      else if (num==5)
      {
        info=new briefingInfo (this, "briefing",5,
"Briefing:

The most important aspect in a war, is to be informed about the movements of
the enemy. Therefore we have build some radarstations troughout the country.

The problem is, that the enemy tries to destroy these radar-stations.
Stop him.");
      }
      else if (num==6)
      {
        info=new briefingInfo (this, "briefing",6,
"Briefing:

Most of the hostile actions are started from a camp, we have now located.
Your order is to destroy it.");
      }
      else if (num==7)
      {
        info=new briefingInfo (this, "briefing",7,
"Briefing:

We have detected one of the main developing and research camps from the
other side. We must stop them developing und improving themselves.");
       }
      else if (num==8)
      {
        info=new briefingInfo (this, "briefing",8,
"Briefing:

The enemy becomes aware of you. He wants to get your head.
I do not think you want to give it away.");
      }
      else if (num==9)
      {
        info=new briefingInfo (this, "briefing",9,
"Briefing: 

The enemy is reported to attack our main production camps soon. Try
to give us more time.");
      }
      else if (num==10)
      {
        info=new briefingInfo (this, "briefing",10,
"Briefing:

Our scientists and spys have investigated, that the enemy have established
a network to comunicate.
We could locate the place where he controles his satilites. The problem is,
that he has developed a way to diguise them.
If you destroy the place, we located, there is the possibility to locate
and destroy his satelites.
If he has lost his communication, he is not able to organize himself anymore.

But be warned: the enemy will defend himself strongly.");
      }
      info->setGeometry (70,270,560,height()-320);
      info->setBackgroundColor (white);
      if (num==1)
      {
        briefingBar = new QScrollBar( 0, 500,  // range
                             1, 50,                        // line/page steps
                             0,                            // inital value
                             QScrollBar::Vertical,         // orientation
                             this, "scrollbar" );
      }
      else if (num==10)
      {
        briefingBar = new QScrollBar( 0, 250,  // range
                             1, 50,                        // line/page steps
                             0,                            // inital value
                             QScrollBar::Vertical,         // orientation
                             this, "scrollbar" );
      }
      else
      {
        briefingBar = new QScrollBar( 0, 0,  // range
                             1, 50,                        // line/page steps
                             0,                            // inital value
                             QScrollBar::Vertical,         // orientation
                             this, "scrollbar" );
      }
      briefingBar->setGeometry (0,270,14,height()-320);
      connect (briefingBar, SIGNAL(valueChanged(int)), info,
               SLOT (moveLabelSlot(int)));
    }

    void Level::resizeEvent (QResizeEvent *)
    {
      briefingBar->setGeometry (0,270,14,height()-320);
      info->setGeometry (70,270,560,height()-320);
      cancel->setGeometry (350, height()-40, 100,30 );
      ok->setGeometry(150, height()-40, 100,30);
    }

    void briefingInfo::moveLabelSlot (int y)
    {
      yText=y;
      briefingLabel->setGeometry (0,-yText,560,600);
    }

    briefingInfo::briefingInfo( QWidget *parent=0, const char *name=0,
                                int num=1, const char *text=0)
                : QWidget( parent, name)
    {
      yText=0;
      briefingLabel = new QLabel (this, "briefing");
      briefingLabel->setText(text);
      if (num==1)
        {briefingLabel->setGeometry (0,-yText,560,600);}
      else if (num==10)
        {briefingLabel->setGeometry (0,-yText,560,250);}
      else
        {briefingLabel->setGeometry (0,-yText,560,100);}
      briefingLabel->setBackgroundColor (white);
    }

    void MainWidget::aboutSlot ()
    {
       ab=new About(this, "egal", picPfad);
       ab->resize (640,400);
       ab->show();
    }

    void MainWidget::tastenSlot ()
    {
       Tasten *t=new Tasten(this, "egal");
       t->resize (640,400);
       t->show();
    }

    void Level::paintEvent(QPaintEvent* event)
    {
      QRect r1= event->rect ();
//      QRect *r1= new QRect (0,0,400,240);
      QPixmap page (r1.size () );
      p.begin( &page );
      QBrush   brush( white );
      QPen     pen( white );
      p.setBrush( brush );
      p.setPen( pen );
      p.drawRect (0,0,width(), height());
      p.setBrush( brush );
      p.setPen( pen );
      if (gNum == 1)
        {bg.load(picPfad+"/earth_1.gif");}
      else if (gNum == 2)
        {bg.load(picPfad+"/earth_2.gif");}
      else if (gNum == 3)
        {bg.load(picPfad+"/earth_3.gif");}
      else if (gNum == 4)
        {bg.load(picPfad+"/earth_4.gif");}
      else if (gNum == 5)
        {bg.load(picPfad+"/earth_5.gif");}
      else if (gNum == 6)
        {bg.load(picPfad+"/earth_6.gif");}
      else if (gNum == 7)
        {bg.load(picPfad+"/earth_7.gif");}
      else if (gNum == 8)
        {bg.load(picPfad+"/earth_8.gif");}
      else if (gNum == 9)
        {bg.load(picPfad+"/earth_9.gif");}
      else if (gNum == 10)
        {bg.load(picPfad+"/earth_10.gif");}

      p.drawPixmap(100,15, bg);
      p.end();
      bitBlt (this, 0, 0, &page);
    }

  void MainWidget::siegSlot (int gruppe, winDatenType winDatenLoc)
  {
    winDaten=winDatenLoc;
    test->hide();
    scrollKarteY->hide();
    scrollKarteX->hide();
    unselectButton->hide();
    energieLabel->hide();
    Karte->hide();
    Leiste->hide();
    sButtonBarV->hide();
    descriptionLabel->hide();
    test->timer->stop();
    title=2;
    repaint (FALSE);
    if (gruppe==2)
    {

//      const char *pfad5="./pic/egmovie.gif";
      movielabel = new QLabel( this, "label0" );
      QString zwPfad=picPfad+"/egmovie.gif";
      const char *pfad4=zwPfad;
      movie = QMovie(pfad4);
      movielabel->setFrameStyle( QFrame::Box | QFrame::Plain );
      movielabel->setMovie( movie );
      movielabel->setMargin(0);
      movielabel->setFixedSize(320,200);
      movielabel->setGeometry ((width()-320)/2,40,320,200);
      movielabel->setBackgroundColor (black);
    }
    else
    {
//      const char *pfad3="./pic/ermovie.gif";
      movielabel = new QLabel( this, "label0" );
      QString zwPfad=picPfad+"/ermovie.gif";
      const char *pfad4=zwPfad;
      movie = QMovie(pfad4);
      movielabel->setFrameStyle( QFrame::Box | QFrame::Plain );
      movielabel->setMovie( movie );
      movielabel->setMargin(0);
      movielabel->setFixedSize(320,200);
      movielabel->setGeometry ((width()-320)/2,40,320,200);
      movielabel->setBackgroundColor (black);
    }
    movielabel->show();
  }
  
  void MainWidget::noMovieSlot (int status)
  {
    if (status<=0)
    {
/*      QString zwPfad2=localPfad+"/pic/titel640x400.gif";
      const char *pfad42=zwPfad2;
      movie=QMovie(pfad42);*/
      noMovie=1;
      repaint ();
//      movie=QMovie("./pic/titel640x400.gif");
    }
  }

  MainWidget::MainWidget( QWidget *parent, const char *name, 
                          QString localPfad="")
        : QWidget( parent, name )
  {
    title=0;
    noMovie=0;
    version=0;
    pauseStatus=0;
//    setMouseTracking (TRUE);
    levelPath=localPfad+"/level";
    picPfad=localPfad+"/pic";
    Dia=new Modal(this, "egal");
    Dia->hide();
    level1Dialog=new Level(this, "egal",2, picPfad);
    ab=new About(this, "egal", picPfad);
    ab->hide();
    level1Dialog->hide();
    setCaption( "Prometheus Project" );
    setMinimumSize( 600, 400 );
    grad=new Grad(this, "egal");
    grad->hide();
//Define Beginning:
//    this->setBackgroundColor (black);
    QString zwPfad=localPfad+"/pic/titelmovie.gif";
    const char *pfad4=zwPfad;
//    QString pfad4="./pic/titelmovie.gif";
    movielabel = new QLabel( this, "label0" );
    //movie = QMovie(picPfad+"/titelmovie.gif");
    movie=QMovie(pfad4);
/*    if (movie.isNull()==TRUE)
    {
      QString zwPfad2=localPfad+"/pic/titel640x400.gif";
      const char *pfad42=zwPfad2;
      movie=QMovie(pfad42);
      movie=QMovie("./pic/titel640x400.gif");
    }*/
    movie.connectStatus (this, SLOT (noMovieSlot(int)));
    movielabel->setFrameStyle( QFrame::Box | QFrame::Plain );
    movielabel->setMovie( movie );
    movielabel->setMargin(0);
    movielabel->setFixedSize(320,200);
    movielabel->setGeometry ((width()-320)/2,40,320,200);
    movielabel->setBackgroundColor (black);
    if (noMovie==0)
      {movielabel->show();}
//    connect (movielabel, SIGNAL(clicked()), this, SLOT (changeTitle()));
//Define Karte:
    test=new PicLoad(this,"TestPic", localPfad);
    test->timer->stop();
//End defining Karte.
//
//Karten - Scroller
    scrollKarteY=new sBarV (this,"Leiste1");
    scrollKarteX=new sBarH (this,"Leiste1");
//Karten Scroller-Ende;
//
//Define Unselect Button:
    unselectButton=new QPushButton( "Unselect All", this, "unselect" );
    connect( unselectButton, SIGNAL(clicked()), test, SLOT(unselectSlot()) );
//End defining unselect-Button.
//
//Define Energie Label:
    energieLabel=new QLabel (this,"energieLabel");
    energieLabel->setAlignment(AlignCenter);
    energieLabel->setFrameStyle(QFrame::Box|QFrame::Raised);
    energieLabel->setLineWidth (1);
    energieLabel->setText("0");
    connect(test, SIGNAL (changeEnergie (int)),
              energieLabel,SLOT(setNum (int)));
    descriptionLabel=new QLabel (this,"descriptionLabel");
    descriptionLabel->setAlignment(AlignLeft);
    descriptionLabel->setFrameStyle(QFrame::Box|QFrame::Raised);
    descriptionLabel->setLineWidth (1);
    descriptionLabel->setText("0");
//Define Minikarte
    Karte = new miniKarte (this, "MiniKarte", picPfad);
    connect( Karte, SIGNAL(scrollKarteSignal(int, int)),
             test, SLOT(scrollKarteSlot(int, int)));
//Define Menu-Bar:
    file = new QPopupMenu;
    file->insertItem("&Open", this, SLOT (open()));
    file->insertItem("&Save", this, SLOT (save()));
    file->insertSeparator();
    pauseID=file->insertItem("&Pause", this, SLOT (pause()));
    file->insertSeparator();
    file->insertItem("&Preferences", this, SLOT (pref()));
    file->insertSeparator();
    file->insertItem("E&xit", qApp, SLOT (quit()));
    file->setCheckable (TRUE);
    level = new QPopupMenu;
    level->insertItem("Level1", this, SLOT (level1()));
    level->insertItem("Level2", this, SLOT (level2()));
    level->insertItem("Level3", this, SLOT (level3()));
    level->insertItem("Level4", this, SLOT (level4()));
    level->insertItem("Level5", this, SLOT (level5()));
    level->insertItem("Level6", this, SLOT (level6()));
    level->insertItem("Level7", this, SLOT (level7()));
    level->insertItem("Level8", this, SLOT (level8()));
    level->insertItem("Level9", this, SLOT (level9()));
    level->insertItem("Level10", this, SLOT (level10()));
    level->insertSeparator();
    level->insertItem("User-Defined-Level", this, SLOT (userLevel()));
    help = new QPopupMenu;
    help->insertItem("&Help", this, SLOT (helpSlot()));
    help->insertItem("&Keys & Mouse", this, SLOT (tastenSlot()));
    help->insertSeparator();
    help->insertItem("&Map Info", this, SLOT (mapInfoHelpSlot()));
    help->insertSeparator();
    help->insertItem("&About", this, SLOT (aboutSlot()));
    menu = new QMenuBar (this);
    menu->setSeparator (QMenuBar::InWindowsStyle);
    menu->insertItem ("&File",file);
    menu->insertItem ("&Levels",level);
    menu->insertSeparator();
    menu->insertItem ("&Help",help);
// End defining menubar;
    Leiste=new leiste(this,"Leiste1", picPfad);
    connect(Leiste , SIGNAL (changeDesc (const char*)),
           descriptionLabel,SLOT(setText (const char*)));
    sButtonBarV = new QScrollBar( 0, 8,          // range
                           1, 1,                       // line/page steps
                           0,                           // inital value
                           QScrollBar::Vertical,        // orientation
                           this, "scrollbar" );
    sButtonBarV->setGeometry(width()-52,192, 12, height ()- 200 );
    connect(test, SIGNAL (changeEnergie (int)),
             Leiste->energieLabel2,SLOT(setNum (int)));
    connect(test, SIGNAL (energieAdd (int)),
             Leiste->energieLabel4,SLOT(setNum (int)));
    connect(test, SIGNAL (energieUsedSignal (int)),
             Leiste->energieLabel6,SLOT(setNum (int)));
    connect(test, SIGNAL (controlersSignal (int)),
             Leiste->controlLabel2,SLOT(setNum (int)));
    connect(test, SIGNAL (controlersUsedSignal (int)),
             Leiste->controlLabel4,SLOT(setNum (int)));
    connect( sButtonBarV, SIGNAL(valueChanged(int)), Leiste,
             SLOT (scrollButtonsV (int)));
    connect(test, SIGNAL (changeEnergie (int)),
             energieLabel,SLOT(setNum (int)));
    connect( test, SIGNAL(changeLeiste(QString)),
             Leiste, SLOT(changeLeisteSlot(QString)));
    connect( test, SIGNAL(refreshMiniKarte(kartetyp)),
             Karte, SLOT(changeKarteSlot(kartetyp)));
    connect (Leiste, SIGNAL (buildCarprodButtonTransmitter()),
             test, SLOT(buildCarprod()));
    connect (Leiste, SIGNAL (buildEnergieButtonTransmitter()),
             test, SLOT(buildEnergie()));
    connect (Leiste, SIGNAL (buildCannonButtonTransmitter()),
             test, SLOT(buildCannon()));
    connect (Leiste, SIGNAL (buildCannon2ButtonTransmitter()),
             test, SLOT(buildCannon2()));
    connect (Leiste, SIGNAL (buildSciButtonTransmitter()),
             test, SLOT(buildSci()));
    connect (Leiste, SIGNAL (buildRadarButtonTransmitter()),
             test, SLOT(buildRadar()));
    connect (Leiste, SIGNAL (buildEnergie2ButtonTransmitter()),
             test, SLOT(buildEnergie2()));
    connect (Leiste, SIGNAL (buildSteuerButtonTransmitter()),
             test, SLOT(buildSteuer()));
    connect (Leiste, SIGNAL (buildZentraleButtonTransmitter()),
             test, SLOT(buildZentrale()));
    connect (Leiste, SIGNAL (buildPan1ButtonTransmitter()),
             test, SLOT(buildPan1()));
    connect (Leiste, SIGNAL (buildPan2ButtonTransmitter()),
             test, SLOT(buildPan2()));
    connect (Leiste, SIGNAL (buildPan3ButtonTransmitter()),
             test, SLOT(buildPan3()));
    connect (Leiste, SIGNAL (buildPan4ButtonTransmitter()),
             test, SLOT(buildPan4()));
    connect (scrollKarteY, SIGNAL (sBarVSignal(int)),
             test, SLOT(scrollKarteV(int)));
    connect (test, SIGNAL (SbarVSlotInSignal(int)),
             scrollKarteY, SLOT(changeSbarVSlotIn(int)));
    connect (scrollKarteX, SIGNAL (sBarHSignal(int)),
             test, SLOT(scrollKarteH(int)));
    connect (test, SIGNAL (SbarHSlotInSignal(int)),
             scrollKarteX, SLOT(changeSbarHSlotIn(int)));
    connect( unselectButton, SIGNAL(clicked()),
             test, SLOT(unselectSlot()) );
    connect( test, SIGNAL(siegSignal(int, winDatenType)),
             this, SLOT(siegSlot(int, winDatenType)) );
    connect( Karte, SIGNAL(autoChanged(int)),
             test, SLOT(autoChangedSlot(int)) );
    connect(grad->lb, SIGNAL (highlighted(const char*)),
            test, SLOT (changeGradSlot(const char*)));
    connect(grad->lb, SIGNAL (selected(const char*)),
            test, SLOT (changeGradSlot(const char*)));
    connect (test, SIGNAL (saveGameSignal (QString)),
             this, SLOT (saveSlot (QString)));

    test->setGeometry(12 , 28, width() - 188, height() - 68 );
    test->kBreite=(width() - 188)/square+2;
    test->kHoehe=(height() - 48)/square+1;
    Karte->kBreite=(width() - 188)/square+2;
    Karte->kHoehe=(height() - 48)/square+1;
    test->maxKarteX=square*karteRangeX-test->kBreite*square;
    test->maxKarteY=square*karteRangeY-test->kHoehe*square;
    scrollKarteY->hoehe=height()-68;
    scrollKarteY->range=test->maxKarteY+square*3;
    scrollKarteY->setGeometry(0,28, 12, height()- 68 );
    scrollKarteX->breite=width()-180;
    scrollKarteX->range=test->maxKarteX+square*3;
    scrollKarteX->setGeometry(12,height()-40, width()-180,12 );
    unselectButton->setGeometry(width()-170, 28, 170, 25);
    energieLabel->setGeometry(width()-170, 28+26, 170, 25);
    Karte->setGeometry(width()-150, 28+26*2, 150, 100);
    Leiste->setGeometry(width()-170, 192, 180, height()-220);
    sButtonBarV->setGeometry(width()-20,192, 16, height ()- 220 );
    descriptionLabel->setGeometry(0, height()-20, width(), 20);
    menu->hide();
    test->hide();
    scrollKarteY->hide();
    scrollKarteX->hide();
    unselectButton->hide();
    energieLabel->hide();
    Karte->hide();
    Leiste->hide();
    sButtonBarV->hide();
    descriptionLabel->hide();

//    openLevel (localPfad+"/level/start.map1");
    loadGame (localPfad+"/autosave.sav");
    test->karteY=square*19;
    test->karteX=square*22;
/*    test->building=-1;
    test->kBreite=(width() - 188)/square+2;
    test->kHoehe=(height() - 48)/square+1;
    Karte->kBreite=(width() - 188)/square+2;
    Karte->kHoehe=(height() - 48)/square+1;
    test->maxKarteX=square*karteRangeX-test->kBreite*square;
    test->maxKarteY=square*karteRangeY-test->kHoehe*square;
    scrollKarteY->hoehe=height()-68;
    scrollKarteY->range=test->maxKarteY+square*3;
    scrollKarteY->setGeometry(0,28, 12, height()- 68 );
    scrollKarteX->breite=width()-180;
    scrollKarteX->range=test->maxKarteX+square*3;*/
  }

    void MainWidget::pause()
    { 
      if (pauseStatus==1)
        {
          test->timer->start(test->geschw);
          file->setItemChecked (pauseID, FALSE);
          pauseStatus=0;
        }
      else
        {
          test->timer->stop();
          file->setItemChecked (pauseID, TRUE);
          test->infoString="Game paused";
          test->repaint(FALSE);
          pauseStatus=1;
        }
    }

    void MainWidget::pref()
    { 
      QTabDialog *tab=new QTabDialog (0,"Test tab dialog");
      tab->setCaption ("Preferences");
      QWidget *tab1=new QWidget (tab, "page1");
      tab->addTab (tab1, "General");
//General:

//Slider:
      QLabel *info1=new QLabel 
                    (tab1, "info1");
      info1->setText ("Refresh Rate:");
      info1->setGeometry (10,10,180,20);
      slider=new QSlider (1,500,25,500,
                         QSlider::Horizontal, tab1, "Slider");
      slider->setGeometry (10,40,200,50);
      slider->setTickmarks(QSlider::Below);
      slider->setTickInterval(100);
      slider->setFocusPolicy (QWidget::TabFocus);
      slider->setFixedHeight(slider->sizeHint().height());
      slider->setValue (test->geschw);

//Buttons:
      QButtonGroup *bg = new QButtonGroup( tab1, "radioGroup" );
      bg->setTitle( "Autosave" );
      QVBoxLayout *vbox = new QVBoxLayout(bg, 10);
      vbox = new QVBoxLayout(bg, 10);
      vbox->addSpacing( bg->fontMetrics().height() );
      rb = new QRadioButton( bg );
      rb->setText( "on" );
      if (test->autoSave==1)
        {rb->setChecked( TRUE );}
      else
        {rb->setChecked( FALSE );}
      vbox->addWidget(rb);
      rb->setMinimumSize( rb->sizeHint() );
      rb2 = new QRadioButton( bg );
      rb2->setText( "off" );
      if (test->autoSave==0)
        {rb2->setChecked( TRUE );}
      else
        {rb2->setChecked( FALSE );}
      vbox->addWidget(rb2);
      rb2->setMinimumSize( rb2->sizeHint() );
      rb2->setMinimumSize( rb2->sizeHint() );
      vbox->activate();
      bg->setGeometry (10,80,200,100);
//Handling:
      QWidget *tab4=new QWidget (tab, "page2");

//Slider KreuzScrolling:
      QLabel *info4=new QLabel 
                    (tab4, "info4");
      info4->setText ("Cross scrolling:");
      info4->setGeometry (10,10,180,20);
      slider2=new QSlider (1,500,25,500,
                         QSlider::Horizontal, tab4, "Slider");
      slider2->setGeometry (10,40,200,50);
      slider2->setTickmarks(QSlider::Below);
      slider2->setTickInterval(100);
      slider2->setFocusPolicy (QWidget::TabFocus);
      slider2->setFixedHeight(slider2->sizeHint().height());
      slider2->setValue (test->crossScrolling);
//Slider CrossRising:
      QLabel *info5=new QLabel 
                    (tab4, "info5");
      info5->setText ("Cross rising:");
      info5->setGeometry (10,70,180,20);
      slider3=new QSlider (1,50,5,50,
                         QSlider::Horizontal, tab4, "Slider");
      slider3->setGeometry (10,100,200,50);
      slider3->setTickmarks(QSlider::Below);
      slider3->setTickInterval(10);
      slider3->setFocusPolicy (QWidget::TabFocus);
      slider3->setFixedHeight(slider3->sizeHint().height());
      slider3->setValue (test->crossRising);

//Slider RectScrolling:
      QLabel *info6=new QLabel 
                    (tab4, "info6");
      info6->setText ("Rect scrolling:");
      info6->setGeometry (10,140,180,20);
      slider4=new QSlider (1,50,5,50,
                         QSlider::Horizontal, tab4, "Slider");
      slider4->setGeometry (10,170,200,50);
      slider4->setTickmarks(QSlider::Below);
      slider4->setTickInterval(10);
      slider4->setFocusPolicy (QWidget::TabFocus);
      slider4->setFixedHeight(slider4->sizeHint().height());
      slider4->setValue (test->selScrolling);

//Slider RectRising:
      QLabel *info7=new QLabel 
                    (tab4, "info7");
      info7->setText ("Rect rising:");
      info7->setGeometry (10,210,180,20);
      slider5=new QSlider (3,25,5,25,
                         QSlider::Horizontal, tab4, "Slider");
      slider5->setGeometry (10,240,200,50);
      slider5->setTickmarks(QSlider::Below);
      slider5->setTickInterval(10);
      slider5->setFocusPolicy (QWidget::TabFocus);
      slider5->setFixedHeight(slider5->sizeHint().height());
      slider5->setValue (test->selRising);

      tab->addTab (tab4, "Handling");
//Network
      QWidget *tab2=new QWidget (tab, "page2");

      QLabel *info2=new QLabel 
                    (tab2, "info2");
      info2->setText ( "This function will be 
implemented later.");
      info2->setGeometry (10,10,180,100);
      info2->show();
      tab->addTab (tab2, "Network");
//Sound:
      QWidget *tab3=new QWidget (tab, "page3");
      QLabel *info3=new QLabel 
                    (tab3, "info3");      
      info3->setText ( "This function will be 
implemented later.");
      info3->setGeometry (10,10,180,100);
      info3->show();
      tab->addTab (tab3, "Sound");

//Sonstige Einstellungen:
      tab->setCancelButton();
      tab->setApplyButton();
      tab->resize (300,400);
      show ();
      tab->show();
      
//      connect (tab, SIGNAL(okButtonPressed()),SLOT (okSlot()));
      connect (tab, SIGNAL(applyButtonPressed()),SLOT (okSlot()));
    }

    void MainWidget::mapInfoHelpSlot ()
    {
//      msg->resize (600,400);
      msg=new QMessageBox ("Map Info", test->mapInfoString, 
                         QMessageBox::Information,
                         QMessageBox::Ok,0,0,0,0,FALSE);
      msg->show();
      msg->raise();
    }

    void MainWidget::helpSlot ()
    {
      msg=new QMessageBox ("Map Info",
"Sorry but at the moment, there is no help avaibel.
Please read the file 'RULES'.
If there are any problems feel free to contact me:

Programing & Design:    Gerhard Vogt
Email:                  gvogt@mps.de
                        vogtg@uni-duesseldorf.de

homepage:               http://www.mps.de/begin
homesite:               http://www.mps.de/pp

It would be nice, if you report me all bugs (but
have first a look on http://www.mps.de/pp/knownbugs.html)
and to write me your opinion. If you have a new good idea,
you can tell it me, and I will try to implement it.

(Da ich in Neuss lebe (liegt bei Kln), also Deutsch spreche
beantworte ich gerne alle Fragen auch auf deutsch).",
                         QMessageBox::Information,
                         QMessageBox::Ok,0,0,0,0,FALSE);
      msg->show();
      msg->raise();
    }


    void MainWidget::okSlot ()
    {
      test->geschw=slider->value();
      test->crossScrolling=slider2->value();
      test->crossRising=slider3->value();
      test->selScrolling=slider4->value();
      test->selRising=slider5->value();
      test->timer->changeInterval(test->geschw);
      if (rb2->isChecked())
        {test->autoSave=0;}
      else
        {test->autoSave=1;}
//      QFile f("~/.kpprc");
      QFile f(".kpprc");
      f.open (IO_WriteOnly);
      QDataStream s (&f);
      s<<test->geschw<<test->crossScrolling<<test->crossRising
       <<test->selScrolling<<test->selRising<<test->autoSave;
      f.close();
    }

    void MainWidget::paintEvent(QPaintEvent* event)
    {
      if (title == 0)
      {
        QRect r1= event->rect ();
        QPixmap page (r1.size () );
        p.begin( &page );
   
        QBrush   brush( black );
        QPen     pen( black );
        p.setBrush( brush );
        p.setPen( pen );
        p.drawRect (0,0,width(), height());
        if (noMovie==1)
          {
            pm.load(picPfad+"/titel640x400.gif");
            p.drawPixmap((width()-640)/2, (height()-400)/2, pm);
            movielabel->hide();            
          }
        p.end();
        bitBlt (this, 0, 0, &page);
      }
      else if (title == 2)
      {
        QRect r1= event->rect ();
        QPixmap page (r1.size () );
        p.begin( &page );
        QBrush   brush( black );
        QPen     pen( black );
        p.setBrush( brush );
        p.setPen( pen );
        p.drawRect (0, 28, width(), height()-28);
        p.setPen( darkGreen );
        QString text;
        text.sprintf ("Destroied buildings: %d", winDaten.killsBuildings);
        p.drawText (50,280,text);
        text.sprintf ("Destroied vehicles:  %d", winDaten.killsCars);
        p.drawText (50,300,text);
        text.sprintf ("Lost vehicles:       %d", winDaten.losesCars);
        p.drawText (50,320,text);
        text.sprintf ("Lost buildings:      %d", winDaten.losesBuildings);
        p.drawText (50,340,text);
        text.sprintf ("Energie (you):       %d", winDaten.EnergieGesamt1);
        p.drawText (50,360,text);
        text.sprintf ("Energie (Enemy):     %d", winDaten.EnergieGesamt2);
        p.drawText (50,380,text);
        if (winDaten.sieg==2)
        {
          p.drawText (50,420,"You won!");
        }
        else
        {
          p.drawText (50,420,
                  "Seems, that the enemy cames closer to his goal!");
        }
        p.end();
        bitBlt (this, 0, 0, &page);
      }
/*      else
      {
        QRect r1= event->rect ();
        QPixmap page (r1.size () );
        p.begin( &page );
   
        QBrush   brush( NoBrush );
        QPen     pen( NoPen );
        p.setBrush( brush );
        p.setPen( pen );
        if (autoOn==1)
          {p.drawPixmap(width()-50, 28+26*2, pAutoOn);}
        else
          {p.drawPixmap(width()-50, 28+26*2, pAutoOff);}
        p.end();
        bitBlt (this, 0, 0, &page);
      }*/
    }

/*  void MainWidget::changeTitle()
  {
    if (title == 0)
    {
      title=1;
      this->setBackgroundColor (backgroundColor ());
      delete (movielabel);
      menu->show();
      test->show();
      scrollKarteY->show();
      scrollKarteX->show();
      unselectButton->show();
      energieLabel->show();
      Karte->show();
      Leiste->show();
      sButtonBarV->show();
      descriptionLabel->show();
      title=1;
    }
  }*/

/*  void MainWidget::mouseMoveEvent(QMouseEvent *event)
  {
    if (event->y()<=5)
    {
      if (test->karteY-square>=0)
        {test->karteY-=square;}
    }
    if (event->y()>=height()-5)
    {
      if (test->karteY+square<=test->maxKarteY+5*square)
        {test->karteY+=square;}
    }
    if (event->x()<=5)
    {
      if (test->karteX+square<=test->maxKarteX+5*square)
        {test->karteX+=square;}
    }
    if (event->x()>=width()-5)
    {
      if (test->karteX-square>=0)
        {test->karteX-=square;}
    }
  }*/

  void MainWidget::keyPressEvent(QKeyEvent* event)
  {
    if (title == 0)
    {
      title=1;
      this->setBackgroundColor (backgroundColor ());
//      delete (movielabel);
      movielabel->hide();
      menu->show();
      test->show();
      scrollKarteY->show();
      scrollKarteX->show();
      unselectButton->show();
      energieLabel->show();
      Karte->show();
      Leiste->show();
      sButtonBarV->show();
      descriptionLabel->show();
      title=1;
      test->timer->start(test->geschw);
    }
    if (event->key()==Key_Up)
    {
      if (test->karteY-square>=0)
        {test->karteY-=square;}
    }
    if (event->key()==Key_Down)
    {
      if (test->karteY+square<=test->maxKarteY+5*square)
        {test->karteY+=square;}
    }
    if (event->key()==Key_Right)
    {
      if (test->karteX+square<=test->maxKarteX+5*square)
        {test->karteX+=square;}
    }
    if (event->key()==Key_Left)
    {
      if (test->karteX-square>=0)
        {test->karteX-=square;}
    }
  }

  void MainWidget::mousePressEvent (QMouseEvent *)
  {
    if (title == 0)
    {
      title=1;
      this->setBackgroundColor (backgroundColor ());
//      delete (movielabel);
      movielabel->hide();
      menu->show();
      test->show();
      scrollKarteY->show();
      scrollKarteX->show();
      unselectButton->show();
      energieLabel->show();
      Karte->show();
      Leiste->show();
      sButtonBarV->show();
      descriptionLabel->show();
      title=1;
      test->timer->start(test->geschw);
    }
  }

void MainWidget::userLevel()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    Dia->resize (260,100);
    if (Dia->exec ())
    {
        QString fName=QFileDialog::getOpenFileName (0,"*.map1",this);
        if (!fName.isEmpty())
        {
          openLevel (fName);
          test->difficulty=1;
          test->text2="22";
          grad=new Grad(this, "egal");
          connect(grad, SIGNAL (gradChangedSignal(int)),
                  test, SLOT (changeGradSlotInt(int)));
          grad->resize(220,220);
          grad->show();
          Leiste->changeLeisteSlot ("none");
          test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
        } 
    }
    test->timer->start(test->geschw);
  }

//////////////////////////////////////////////
//  To open map-Files:
//////////////////////////////////////////////

  void MainWidget::openLevel(const char *fName)
  {
//    if (!fName.isEmpty())
    {
       QFile f(fName);
       f.open (IO_ReadOnly);
       int versionLoc;
       QDataStream s (&f);
       s>>versionLoc;
       f.close();
       if (versionLoc!=0)
       {
         QMessageBox *msgLoc=
              new QMessageBox ("Map Info",
"This version of PP can only open *.map1 files.
The file you tried to open, must be corrupted, or of
a newer type.

Please look at 

http://www.mps.de/pp
 
for a newer version of this Program.",
                          QMessageBox::Information,
                          QMessageBox::Ok,0,0,0,0,FALSE);
         msgLoc->show();
         msgLoc->raise();
       }
       else
       {
       QFile f(fName);
       f.open (IO_ReadOnly);
       QDataStream s (&f);
       s>> version>>test->geschw;
       for (int i=0; i<=maxCars-1; i++)
       {
         s>>test->cars[i].jeepX
         >>test->cars[i].jeepY
         >>test->cars[i].selected
         >>test->cars[i].destinationX
         >>test->cars[i].destinationY
         >>test->cars[i].jeepS1x
         >>test->cars[i].jeepS1y
         >>test->cars[i].jeepS2x
         >>test->cars[i].jeepS2y
         >>test->cars[i].jeepS3x
         >>test->cars[i].jeepS3y
         >>test->cars[i].verlauf
         >>test->cars[i].health
         >>test->cars[i].power
         >>test->cars[i].shootVerlauf
         >>test->cars[i].shootX
         >>test->cars[i].shootY
         >>test->cars[i].gruppe
         >>test->cars[i].shootFreq
         >>test->cars[i].type
         >>test->cars[i].pic
         >>test->cars[i].stepps
         >>test->cars[i].wache
         >>test->cars[i].wacheX
         >>test->cars[i].wacheY;
       }
       for (int i=0; i<=maxBuildings-1; i++)
       {
         s>>test->buildings[i].id
         >>test->buildings[i].selected
         >>test->buildings[i].ortX
         >>test->buildings[i].ortY
         >>test->buildings[i].power
         >>test->buildings[i].gruppe
         >>test->buildings[i].bWidth
         >>test->buildings[i].health
         >>test->buildings[i].building
         >>test->buildings[i].shootX
         >>test->buildings[i].shootY
         >>test->buildings[i].shootFreq
         >>test->buildings[i].shootVerlauf;
       }
       for (int x=0; x<= karteRangeX; x++)
         for (int y=0; y<= karteRangeY; y++)
         {
           s>>test->buildingKarte [x][y]
           >>test->baumKarte [x][y]
           >>test->fogKarte [x][y]
           >>test->fogKarte2 [x][y];
         }
       double energieD;
       double energie2D;

       s>>test->winDaten.EnergieGesamt1
       >>test->winDaten.EnergieGesamt2
       >>test->winDaten.killsCars
       >>test->winDaten.losesCars
       >>test->winDaten.killsBuildings
       >>test->winDaten.losesBuildings
       >>test->winDaten.sieg
       >>test->xOld
       >>test->yOld
       >>test->rMouseW
       >>test->building
       >>test->pressedSec
       >>test->mPressed
       >>test->navX
       >>test->navY
       >>test->nav2X
       >>test->nav2Y
       >>energieD
       >>test->addEnergie
       >>energie2D
       >>test->addEnergie2
       >>test->autoOn
       >>Karte->autoOn
       >>test->typeOfCar
       >>test->mapInfoString
       >>test->maxKarteY
       >>test->kBreite
       >>test->kHoehe
       >>test->maxKarteX
       >>test->sciBuild
       >>test->geschw
       >>test->moveKarteX
       >>test->moveKarteY
       >>test->selectCounter
       >>test->crossScrolling
       >>test->crossRising
       >>test->selScrolling
       >>test->selRising
       >>test->steuerCars
       >>test->steuerCars2
       >>test->steuerUsed
       >>test->steuerUsed2
       >>test->energieUsed
       >>test->energieUsed2
       >>test->karteX
       >>test->karteY
       >>test->bidCounter
       >>test->leiste
       >>test->bselected
       >>test->cidCounter
       >>test->az
       >>test->unselected
       >>test->selRx1
       >>test->selRy1
       >>test->selRx2
       >>test->selRy2
       >>test->karteXalt
       >>test->karteYalt
       >>test->mStartX
       >>test->mStartY
       >>Leiste->sci
       >>test->autoMoveKarteX
       >>test->autoMoveKarteY
       >>test->autoScroll
       >>test->carCount2
       >>test->carsSend2
       >>test->carsAngriff2
       >>test->attackBuilding;

       test->energie=(double) energieD;
       test->energie2=(long) energie2D;

       f.close();
       test->building=-1;
       test->kBreite=(width() - 188)/square+2;
       test->kHoehe=(height() - 48)/square+1;
       Karte->kBreite=(width() - 188)/square+2;
       Karte->kHoehe=(height() - 48)/square+1;
       test->maxKarteX=square*karteRangeX-test->kBreite*square;
       test->maxKarteY=square*karteRangeY-test->kHoehe*square;
       scrollKarteY->hoehe=height()-68;
       scrollKarteY->range=test->maxKarteY+square*3;
       scrollKarteY->setGeometry(0,28, 12, height()- 68 );
       scrollKarteX->breite=width()-180;
       scrollKarteX->range=test->maxKarteX+square*3;
       test->fogKarte2=test->fogKarteSchwarz;
       test->fogKarte=test->fogKarteSchwarz;
       test->az=0;
       test->autoOn=1;
       Karte->autoOn=1;
    }
    }
  }

  void MainWidget::loadGame (QString fName)
  {
       QFile f(fName);
       f.open (IO_ReadOnly);
       int versionLoc;
       QDataStream s (&f);
       s>>versionLoc;
       f.close();
       if (versionLoc!=0)
       {
         QMessageBox *msgLoc=
              new QMessageBox ("Map Info",
        "This version of PP can only open *.map1 files.
The file you tried to open, must be corrupted, or of
a newer type.
 
Please look at 
 
http://www.mps.de/pp
 
for a newer version of this Program.",
                          QMessageBox::Information,
                          QMessageBox::Ok,0,0,0,0,FALSE);
         msgLoc->show();
         msgLoc->raise();
       }
       else
       {
       QFile f(fName);
       f.open (IO_ReadOnly);
       QDataStream s (&f);
       s>> version>>test->geschw;
       for (int i=0; i<=maxCars-1; i++)
       {
         s>> 
         test->cars[i].jeepX
         >>test->cars[i].jeepY
         >>test->cars[i].selected
         >>test->cars[i].destinationX
         >>test->cars[i].destinationY
         >>test->cars[i].jeepS1x
         >>test->cars[i].jeepS1y
         >>test->cars[i].jeepS2x
         >>test->cars[i].jeepS2y
         >>test->cars[i].jeepS3x
         >>test->cars[i].jeepS3y
         >>test->cars[i].verlauf
         >>test->cars[i].health
         >>test->cars[i].power
         >>test->cars[i].shootVerlauf
         >>test->cars[i].shootX
         >>test->cars[i].shootY
         >>test->cars[i].gruppe
         >>test->cars[i].shootFreq
         >>test->cars[i].type
         >>test->cars[i].pic
         >>test->cars[i].stepps
         >>test->cars[i].wache
         >>test->cars[i].wacheX
         >>test->cars[i].wacheY;
       }
       for (int i=0; i<=maxBuildings-1; i++)
       {
         s>>test->buildings[i].id
         >>test->buildings[i].selected
         >>test->buildings[i].ortX
         >>test->buildings[i].ortY
         >>test->buildings[i].power
         >>test->buildings[i].gruppe
         >>test->buildings[i].bWidth
//         <<test->buildings[i].rBuilding
         >>test->buildings[i].health
         >>test->buildings[i].building
         >>test->buildings[i].shootX
         >>test->buildings[i].shootY
         >>test->buildings[i].shootFreq
         >>test->buildings[i].shootVerlauf;
       }
       for (int x=0; x<= karteRangeX; x++)
         for (int y=0; y<= karteRangeY; y++)
         {
           s>>test->buildingKarte [x][y]
           >>test->baumKarte [x][y]
           >>test->fogKarte [x][y]
           >>test->fogKarte2 [x][y];
         }
       double energieD;
       double energie2D;

       s>>test->winDaten.EnergieGesamt1
       >>test->winDaten.EnergieGesamt2
       >>test->winDaten.killsCars
       >>test->winDaten.losesCars
       >>test->winDaten.killsBuildings
       >>test->winDaten.losesBuildings
       >>test->winDaten.sieg
       >>test->xOld
       >>test->yOld
       >>test->rMouseW
       >>test->building
       >>test->pressedSec
       >>test->mPressed
       >>test->navX
       >>test->navY
       >>test->nav2X
       >>test->nav2Y
       >>energieD
       >>test->addEnergie
       >>energie2D
       >>test->addEnergie2
       >>test->autoOn
       >>Karte->autoOn
       >>test->typeOfCar
       >>test->mapInfoString
       >>test->maxKarteY
       >>test->kBreite
       >>test->kHoehe
       >>test->maxKarteX
       >>test->sciBuild
       >>test->geschw
       >>test->moveKarteX
       >>test->moveKarteY
       >>test->selectCounter
       >>test->crossScrolling
       >>test->crossRising
       >>test->selScrolling
       >>test->selRising
       >>test->steuerCars
       >>test->steuerCars2
       >>test->steuerUsed
       >>test->steuerUsed2
       >>test->energieUsed
       >>test->energieUsed2
       >>test->karteX
       >>test->karteY
       >>test->bidCounter
       >>test->leiste
       >>test->bselected
       >>test->cidCounter
       >>test->az
       >>test->unselected
       >>test->selRx1
       >>test->selRy1
       >>test->selRx2
       >>test->selRy2
       >>test->karteXalt
       >>test->karteYalt
       >>test->mStartX
       >>test->mStartY
       >>Leiste->sci
       >>test->autoMoveKarteX
       >>test->autoMoveKarteY
       >>test->autoScroll
       >>test->carCount2
       >>test->carsSend2
       >>test->carsAngriff2
       >>test->attackBuilding
       >>test->difficulty;

       test->energie=(double) energieD;
       test->energie2=(long) energie2D;

       f.close();
       test->building=-1;
       test->kBreite=(width() - 188)/square+2;
       test->kHoehe=(height() - 48)/square+1;
       Karte->kBreite=(width() - 188)/square+2;
       Karte->kHoehe=(height() - 48)/square+1;
       test->maxKarteX=square*karteRangeX-test->kBreite*square;
       test->maxKarteY=square*karteRangeY-test->kHoehe*square;
       scrollKarteY->hoehe=height()-68;
       scrollKarteY->range=test->maxKarteY+square*3;
       scrollKarteY->setGeometry(0,28, 12, height()- 68 );
       scrollKarteX->breite=width()-180;
       scrollKarteX->range=test->maxKarteX+square*3;
       test->fogKarte2=test->fogKarteSchwarz;
       test->az=0;
      }
  }

//////////////////////////////////////////////
//  To open game-Files:
//////////////////////////////////////////////

  void MainWidget::open()
  {
    QString fName=QFileDialog::getOpenFileName (0,"*.sav",this);
    if (!fName.isEmpty())
    {
      loadGame (fName);
    }
  }

  void MainWidget::saveSlot (QString fName)
  {
       QFile f(fName);
       f.open (IO_WriteOnly);
       QDataStream s (&f);
//       s<<(Q_INT16) test->geschw;
       version=0;
       s<<(int)version<<(int) test->geschw;
       for (int i=0; i<=maxCars-1; i++)
       {
         s<<
         test->cars[i].jeepX
         <<test->cars[i].jeepY
         <<test->cars[i].selected
         <<test->cars[i].destinationX
         <<test->cars[i].destinationY
         <<test->cars[i].jeepS1x
         <<test->cars[i].jeepS1y
         <<test->cars[i].jeepS2x
         <<test->cars[i].jeepS2y
         <<test->cars[i].jeepS3x
         <<test->cars[i].jeepS3y
         <<test->cars[i].verlauf
         <<test->cars[i].health
         <<test->cars[i].power
         <<test->cars[i].shootVerlauf
         <<test->cars[i].shootX
         <<test->cars[i].shootY
         <<test->cars[i].gruppe
         <<test->cars[i].shootFreq
         <<test->cars[i].type
         <<test->cars[i].pic
         <<test->cars[i].stepps
         <<test->cars[i].wache
         <<test->cars[i].wacheX
         <<test->cars[i].wacheY;
       }
       for (int i=0; i<=maxBuildings-1; i++)
       {
         s<<test->buildings[i].id
         <<test->buildings[i].selected
         <<test->buildings[i].ortX
         <<test->buildings[i].ortY
         <<test->buildings[i].power
         <<test->buildings[i].gruppe
         <<test->buildings[i].bWidth
         <<test->buildings[i].health
         <<test->buildings[i].building
         <<test->buildings[i].shootX
         <<test->buildings[i].shootY
         <<test->buildings[i].shootFreq
         <<test->buildings[i].shootVerlauf;
       }
       for (int x=0; x<= karteRangeX; x++)
         for (int y=0; y<= karteRangeY; y++)
         {
           s<<test->buildingKarte [x][y]
           <<test->baumKarte [x][y]
           <<test->fogKarte [x][y]
           <<test->fogKarte2 [x][y];
         }

       double energieD=(double)test->energie;
       double energie2D=(double)test->energie2;

       s<<(int)test->winDaten.EnergieGesamt1
       <<(int)test->winDaten.EnergieGesamt2
       <<(int)test->winDaten.killsCars
       <<(int)test->winDaten.losesCars
       <<(int)test->winDaten.killsBuildings
       <<(int)test->winDaten.losesBuildings
       <<(int)test->winDaten.sieg
    //    QRect rMouse, rMouseP;
       <<(int)test->xOld
       <<(int)test->yOld
       <<(int)test->rMouseW
       <<(int)test->building
       <<(int)test->pressedSec
       <<(int)test->mPressed
       <<(int)test->navX
       <<(int)test->navY
       <<(int)test->nav2X
       <<(int)test->nav2Y
       <<(double)energieD
       <<(int)test->addEnergie
       <<(double)energie2D
       <<(int)test->addEnergie2
       <<test->autoOn
       <<Karte->autoOn
       <<(int)test->typeOfCar
       <<test->mapInfoString
       <<test->maxKarteY
       <<test->kBreite
       <<test->kHoehe
       <<test->maxKarteX
       <<test->sciBuild
       <<test->geschw
       <<test->moveKarteX
       <<test->moveKarteY
       <<test->selectCounter
       <<test->crossScrolling
       <<test->crossRising
       <<test->selScrolling
       <<test->selRising
       <<test->steuerCars
       <<test->steuerCars2
       <<test->steuerUsed
       <<test->steuerUsed2
       <<test->energieUsed
       <<test->energieUsed2
       <<test->karteX
       <<test->karteY
       <<test->bidCounter
       <<test->leiste
       <<test->bselected
       <<test->cidCounter
       <<test->az
       <<test->unselected
       <<test->selRx1
       <<test->selRy1
       <<test->selRx2
       <<test->selRy2
       <<test->karteXalt
       <<test->karteYalt
       <<test->mStartX
       <<test->mStartY
       <<Leiste->sci
       <<test->autoMoveKarteX
       <<test->autoMoveKarteY
       <<test->autoScroll
       <<test->carCount2
       <<test->carsSend2
       <<test->carsAngriff2
       <<test->attackBuilding
       <<test->difficulty;
       f.close();
  }

  void MainWidget::save()
  {
    QString fName=QFileDialog::getSaveFileName (0,"*.sav",this);
    if (!fName.isEmpty())
    {
       saveSlot (fName);
    }
    else
    {}
  }

  void MainWidget::level1()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal", 1, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level1.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level2()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal", 2, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level2.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      }
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level3()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal", 3, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level3.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level4()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",4, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level4.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level5()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",5, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level5.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level6()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",6, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level6.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level7()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",7, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level7.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level8()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",8, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level8.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level9()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",9, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level9.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }

  void MainWidget::level10()
  {
    test->timer->stop();
    Dia=new Modal(this, "egal");
    level1Dialog=new Level(this, "egal",10, picPfad);
    Dia->resize (260,100);
    level1Dialog->resize (600,420);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        openLevel (levelPath+"/level10.map1");
        test->difficulty=1;
        test->text2="22";
        grad=new Grad(this, "egal");
        connect(grad, SIGNAL (gradChangedSignal(int)),
                test, SLOT (changeGradSlotInt(int)));
        grad->resize(220,220);
        grad->show();
        Leiste->changeLeisteSlot ("none");
        test->az=0;
        test->setBackgroundColor (backgroundColor ());
        scrollKarteY->setBackgroundColor (backgroundColor ());
        scrollKarteX->setBackgroundColor (backgroundColor ());
        unselectButton->setBackgroundColor (backgroundColor ());
        energieLabel->setBackgroundColor (backgroundColor ());
        Karte->setBackgroundColor (backgroundColor ());
        Leiste->setBackgroundColor (backgroundColor ());
        sButtonBarV->setBackgroundColor (backgroundColor ());
        descriptionLabel->setBackgroundColor (backgroundColor ());
        menu->setBackgroundColor (backgroundColor ());
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
        menu->show();
        if (title==2)
          {movielabel->hide();}
      } 
    }
    test->timer->start(test->geschw);
  }


void Grad::changeGradSlotInt(int grad)
    {
      num=grad+1;
      emit gradChangedSignal (num);
    }

  void MainWidget::level2_alt()
  {
    test->timer->stop();
    Modal *Dia=new Modal(this, "egal");
    Level *level1Dialog=new Level(this, "egal",2);
//    level1Dialog->setGeometry( width()/2-250, height()/2-150, 500,450 );
//    Dia->setGeometry( width()/2-250, height()/2-150, 260,100 );
    Dia->resize (260,100);
    level1Dialog->resize (500,450);
    if (Dia->exec ())
    {
      if (level1Dialog->exec ())
      {
        delete (test);
        test=new PicLoad(this,"TestPic",2);
        delete (Leiste);
        delete (sButtonBarV);
        Leiste=new leiste(this,"Leiste1", picPfad);
        Leiste->show();
        sButtonBarV = new QScrollBar( 0, 5,          // range
                           1, 1,                       // line/page steps
                           0,                           // inital value
                           QScrollBar::Vertical,        // orientation
                           this, "scrollbar" );
        test->setGeometry(12 , 28, width() - 200, height() - 48 );
        test->show();
        connect(test, SIGNAL (changeEnergie (int)),
                 Leiste->energieLabel2,SLOT(setNum (int)));
        connect(test, SIGNAL (energieAdd (int)),
                 Leiste->energieLabel4,SLOT(setNum (int)));
        connect(test, SIGNAL (energieUsedSignal (int)),
                 Leiste->energieLabel6,SLOT(setNum (int)));
        connect(test, SIGNAL (controlersSignal (int)),
                 Leiste->controlLabel2,SLOT(setNum (int)));
        connect(test, SIGNAL (controlersUsedSignal (int)),
                 Leiste->controlLabel4,SLOT(setNum (int)));
        connect( Karte, SIGNAL(scrollKarteSignal(int, int)),
                 test, SLOT(scrollKarteSlot(int, int)));
        connect(Leiste , SIGNAL (changeDesc (const char*)),
                 descriptionLabel,SLOT(setText (const char*)));
        connect( sButtonBarV, SIGNAL(valueChanged(int)), Leiste,
                 SLOT (scrollButtonsV (int)));
        connect( test, SIGNAL(changeLeiste(QString)),
                 Leiste, SLOT(changeLeisteSlot(QString)));
        connect( test, SIGNAL(refreshMiniKarte(kartetyp)),
                 Karte, SLOT(changeKarteSlot(kartetyp)));
        connect (Leiste, SIGNAL (buildCarprodButtonTransmitter()),
                 test, SLOT(buildCarprod()));
        connect (Leiste, SIGNAL (buildEnergieButtonTransmitter()),
                 test, SLOT(buildEnergie()));
        connect (Leiste, SIGNAL (buildCannonButtonTransmitter()),
                 test, SLOT(buildCannon()));
        connect (Leiste, SIGNAL (buildCannon2ButtonTransmitter()),
                 test, SLOT(buildCannon2()));
        connect (Leiste, SIGNAL (buildSciButtonTransmitter()),
                 test, SLOT(buildSci()));
        connect (Leiste, SIGNAL (buildRadarButtonTransmitter()),
                 test, SLOT(buildRadar()));
        connect (Leiste, SIGNAL (buildZentraleButtonTransmitter()),
                 test, SLOT(buildZentrale()));
        connect (Leiste, SIGNAL (buildEnergie2ButtonTransmitter()),
                 test, SLOT(buildEnergie2()));
        connect (Leiste, SIGNAL (buildSteuerButtonTransmitter()),
                 test, SLOT(buildSteuer()));
        connect (Leiste, SIGNAL (buildPan1ButtonTransmitter()),
                 test, SLOT(buildPan1()));
        connect (Leiste, SIGNAL (buildPan2ButtonTransmitter()),
                 test, SLOT(buildPan2()));
        connect (Leiste, SIGNAL (buildPan3ButtonTransmitter()),
                 test, SLOT(buildPan3()));
        connect (Leiste, SIGNAL (buildPan4ButtonTransmitter()),
                 test, SLOT(buildPan4()));
        connect (scrollKarteY, SIGNAL (sBarVSignal(int)),
                 test, SLOT(scrollKarteV(int)));
        connect (test, SIGNAL (SbarVSlotInSignal(int)),
                 scrollKarteY, SLOT(changeSbarVSlotIn(int)));
        connect (scrollKarteX, SIGNAL (sBarHSignal(int)),
                 test, SLOT(scrollKarteH(int)));
        connect (test, SIGNAL (SbarHSlotInSignal(int)),
                 scrollKarteX, SLOT(changeSbarHSlotIn(int)));
        connect( test, SIGNAL(siegSignal(int, winDatenType)),
                 this, SLOT(siegSlot(int, winDatenType)) );
        connect(test, SIGNAL (changeEnergie (int)),
                 energieLabel,SLOT(setNum (int)));
        connect( Karte, SIGNAL(autoChanged(int)),
                 test, SLOT(autoChangedSlot(int)) );
        test->setGeometry(12 , 28, width() - 188, height() - 68 );
        test->kBreite=(width()-188)/square+2;
        test->kHoehe=(height()-48)/square+1;
        Karte->kBreite=(width()-188)/square+2;
        Karte->kHoehe=(height()-48)/square+1;
        test->maxKarteX=square*karteRangeX-test->kBreite*square;
        test->maxKarteY=square*karteRangeY-test->kHoehe*square;
        scrollKarteY->hoehe=height()-68;
        scrollKarteY->range=test->maxKarteY+square*3;
        scrollKarteY->setGeometry(0,28, 12, height()- 68 );
        scrollKarteX->breite=width()-180;
        scrollKarteX->range=test->maxKarteX+square*3;
        scrollKarteX->setGeometry(12,height()-40, width()-180,12 );
        unselectButton->setGeometry(width()-170, 28, 170, 25);
        energieLabel->setGeometry(width()-170, 28+26, 170, 25);
        Karte->setGeometry(width()-150, 28+26*2, 150, 100);
        Leiste->setGeometry(width()-170, 192, 150, height()-220);
        sButtonBarV->setGeometry(width()-20,192, 16, height ()- 220 );
        descriptionLabel->setGeometry(0, height()-20, width(), 20);
        this->setBackgroundColor (backgroundColor ());
        test->show();
        scrollKarteY->show();
        scrollKarteX->show();
        unselectButton->show();
        energieLabel->show();
        Karte->show();
        Leiste->show();
        sButtonBarV->show();
        descriptionLabel->show();
      }
    }
    test->timer->start(test->geschw);
  }

    void MainWidget::resizeEvent (QResizeEvent *)
    {
        test->setGeometry(12 , 28, width() - 188, height() - 68 );
        test->kBreite=(width() - 188)/square+2;
        test->kHoehe=(height() - 48)/square+1;
        Karte->kBreite=(width() - 188)/square+2;
        Karte->kHoehe=(height() - 48)/square+1;
        test->maxKarteX=square*karteRangeX-test->kBreite*square;
        test->maxKarteY=square*karteRangeY-test->kHoehe*square;
        scrollKarteY->hoehe=height()-68;
        scrollKarteY->range=test->maxKarteY+square*3;
        scrollKarteY->setGeometry(0,28, 12, height()- 68 );
        scrollKarteX->breite=width()-180;
        scrollKarteX->range=test->maxKarteX+square*3;
        scrollKarteX->setGeometry(12,height()-40, width()-180,12 );
        unselectButton->setGeometry(width()-170, 28, 170, 25);
        energieLabel->setGeometry(width()-170, 28+26, 170, 25);
        Karte->setGeometry(width()-150, 28+26*2, 150, 100);
        Leiste->setGeometry(width()-170, 192, 180, height()-220);
        sButtonBarV->setGeometry(width()-20,192, 16, height ()- 220 );
        descriptionLabel->setGeometry(0, height()-20, width(), 20);
/*
      if (title == 0)
      {
        title=1;
      this->setBackgroundColor (backgroundColor ());
      delete (movielabel);
      menu->show();
      test->show();
      scrollKarteY->show();
      scrollKarteX->show();
      unselectButton->show();
      energieLabel->show();
      Karte->show();
      Leiste->show();
      sButtonBarV->show();
      descriptionLabel->show();
      title=1;
      test->timer->start(test->geschw);
    }*/
    }

int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    QString localPath, localPath2;
    if (argc>1)
    {
        
       localPath2=argv[1];
       localPath=localPath2.stripWhiteSpace();
/*       w.test->picPfad=localPath+"/pic";
       w.picPfad=localPath+"/pic";
       w.Leiste->picPfad2=localPath+"/pic";
       w.levelPath=localPath+"/level";*/
    }
    else
    {
//       w.test->picPfad="./pic";
/*       w.test->picPfad="/dosc/jeep/pic";
       w.test->picPfad2="/dosc/jeep/pic";
       w.picPfad="./pic";
       w.Leiste->picPfad2="./pic";
       w.levelPath="./level";*/
       localPath=".";
    }
    
    MainWidget w(0, "Main", localPath);
    a.setMainWidget( &w );
    w.show();
    return a.exec();
}
