/*
###########################################################################
#                                                                         #
# File   :	minikarte.cpp                                             #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include "minikarte.h"

  miniKarte::miniKarte(QWidget *parent=0, const char *name=0, 
             QString picPfad="")
           :QWidget (parent, name)
  {
     setMouseTracking (FALSE);
     c[1].setRgb (0,150,0);
     c[2].setRgb (0,50,0);
     c[3].setRgb (50,50,50);
     pAutoOn.load(picPfad+"/autoon.gif");
     pAutoOff.load(picPfad+"/autoof.gif");
//     pAutoOff.load(picPfad+"/picpan3.gif");
     autoOn=1;
  }

void miniKarte::paintEvent(QPaintEvent* event)
  {
    r1= event->rect ();
    QPixmap page (r1.size () );
    QPainter p;
    p.begin( &page );
//    c=new QColor (100,100,100);
    for (int x=0; x<=karteRangeX2; x++)
      for (int y=0; y<=karteRangeY2; y++)
      {

//schwarz

        if (mKarte.fog2[y][x]==2)
          {p.setPen (black);
           p.setBrush (black);}

//ohne nebel

        else if (mKarte.fog[y][x]==1)
        {
          if ((mKarte.karte[y][x]==1))
            {
               p.setPen (c[1]);
               p.setBrush (c[1]);
            }
          else if ((mKarte.karte[y][x]==2)||(mKarte.karte[y][x]==4))
            {p.setPen (blue);
             p.setBrush (blue);}
          else if ((mKarte.karte[y][x]==3)||(mKarte.karte[y][x]==5))
            {p.setPen (red);
             p.setBrush (red);}
          else 
            {
               p.setPen (c[3]);
               p.setBrush (c[3]);
            }
        }
//mit nebel:
        else if (mKarte.fog2[y][x]==3)
        {
          if ((mKarte.karte[y][x]==1))
            {
               p.setPen (c[2]);
               p.setBrush (c[2]);
             }
/*          else if ((mKarte.karte[y][x]==2)||(mKarte.karte[y][x]==4))
            {
              p.setPen (darkBlue);
              p.setBrush (darkBlue);
            }*/
/*          else if ((mKarte.karte[y][x]==3)||(mKarte.karte[y][x]==5))
            {p.setPen (darkRed);
             p.setBrush (darkRed);}*/
          else 
            {
               p.setPen (c[3]);
               p.setBrush (c[3]);
            }
        }
//        p.drawPoint (x,y);
        p.drawRect (x*2, y*2,2,2);
      }
    p.drawWinFocusRect (mKarte.windowX*2,mKarte.windowY*2,
                        kBreite*2,kHoehe*2);
    if (autoOn==1)
      {p.drawPixmap(100, 0, pAutoOn);}
    else
      {p.drawPixmap(100, 0, pAutoOff);}
    p.end();
    bitBlt (this, 0, 0, &page);
  }

    void miniKarte::mouseReleaseEvent (QMouseEvent *event)
    {
      if (event->x()<=100)
      {
        int x=event->x()/2-4;
        int y=event->y()/2-4;
        if (x<0) {x=0;}
        if (y<0) {y=0;}
        if (x>karteRangeX2-kBreite+3) {x=karteRangeX2-kBreite+3;}
        if (y>karteRangeY2-kHoehe+3) {y=karteRangeY2-kHoehe+3;}
        emit scrollKarteSignal(x,y);
      }
      else
      {
        if (autoOn==1)
        {
          autoOn=0;
          emit autoChanged (0);
        }
          else
        {
          autoOn=1;
          emit autoChanged (1);
        }
      }
    }

    void miniKarte::mouseMoveEvent (QMouseEvent *event)
    {
      if (event->x()<=100)
      {
        int x=event->x()/2-4;
        int y=event->y()/2-4;
        if (x<0) {x=0;}
        if (y<0) {y=0;}
        if (x>karteRangeX2-kBreite+3) {x=karteRangeX2-kBreite+3;}
        if (y>karteRangeY2-kHoehe+3) {y=karteRangeY2-kHoehe+3;}
        emit scrollKarteSignal(x,y);
      }
    }

void miniKarte::changeKarteSlot (kartetyp karte)
  {
    mKarte=karte;
    repaint (FALSE);
  }
