/*
###########################################################################
#                                                                         #
# File   :	minikarte.h                                               #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include <qpushbt.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qcolor.h>

#ifndef MINIKARTE_H
#define MINIKARTE_H

const int karteRangeX2=49, karteRangeY2=49;

class miniKarte : public QWidget {

Q_OBJECT

    public:
       miniKarte (QWidget *parent=0, const char *name=0,
                  QString picPfad="");
       void paintEvent(QPaintEvent* event);
       void mouseMoveEvent (QMouseEvent *event);
       void mouseReleaseEvent (QMouseEvent *event);
       int kBreite, kHoehe, autoOn;
       QRect r1;
       QPixmap pAutoOn, pAutoOff;
       QColor c[5];
       typedef struct
       {
         int karte[karteRangeY2+1][karteRangeX2+1];
         int fog[karteRangeY2+1][karteRangeX2+1];
         int fog2[karteRangeY2+1][karteRangeX2+1];
         int windowX, windowY;
       } kartetyp;
       kartetyp mKarte;

public slots:
  void changeKarteSlot (kartetyp karte);

signals:
  void scrollKarteSignal (int x, int y);
  void autoChanged (int num);

};

#endif
