/*
###########################################################################
#                                                                         #
# File   :	pic2.h                                                    #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include <qapp.h>
#include <qpainter.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qtooltip.h>
#include <qrect.h>
#include <qevent.h>
#include "stepp.h"
#include <stdlib.h>
#include <qfile.h>
#include <qdstream.h>
#include <string.h>

#ifndef PICLOAD_H
#define PICLOAD_H
const int square=60, maxCars=200, maxBuildings=180;
const QString pfad="/dosd/panzer";

//KARTENLEGENDE:
// 1 -> befahrbar
// 0 -> Fels1
// 2 -> car Gruppe1
// 4 -> building Gruppe1
// 3 -> car Gruppe2
// 5 -> building Gruppe2
// 6 -> Fels2
// 7 -> Fels3
// 10 -> Baum1
// 11 -> Baum2
// 12 -> Baum3
// 20 -> Strand
// ..
// 33 -> Strand

//BUILDINLEGENDE:
// 0 -> Zentrale
// 1 -> CarProd
// 2 -> Energie
// 3 -> Cannon
// 4 -> Cannon2
// 5 -> Radar
// 6 -> Sci
// 7 -> Steuer
// 8 -> Energie2


class PicLoad : public QWidget {
 
    Q_OBJECT

public:

    PicLoad(QWidget *parent=0, const char *name=0,
            QString localPfad="");
    void paintEvent(QPaintEvent* event);
    void mouseReleaseEvent (QMouseEvent* event);
    void mousePressEvent (QMouseEvent *event);
    void mouseMoveEvent (QMouseEvent* event);
    void mouseEvent (QMouseEvent* event);
    void unselectAll ();
    void setCidCounter ();
    void setBidCounter ();
    void buildCarComp(int type, int bselected);
    void buildJeep ();
    void paintShoot(int x,int y,int x2,int y2,
                    int verlaufEnde, int verlauf, int type);

    QPixmap pm, shoot1, shoot2;
    QPixmap baum1, pCarprod, pZentrale, pEnergie;
    QPixmap baum2, pCannon, pCannon2, pSci, pRadar;
    QPixmap stone, navPic, stone2, stone3, baum3;
    QRect r2;
    QRect rMouse, rMouseP;
    const char *test3;

//////////////nicht abgespeichert////////////////
    int difficulty;
    int mCounter, saveCounter, autoSave;
/////////////////////////////////////////////////

//////////////abgespeichert////////////////
    int autoMoveKarteX, autoMoveKarteY, autoScroll;
//Speichert ob und wie weit sich die Karte beim nhern 
//an die Kante scrollen soll.
    int carCount2, carsSend2, carsAngriff2;
// carCount2 gibt die aktuelle anzahl der vorhandenen waagen an
// carsSend2 speichert die ausgesandten Waagen zwischen
// carsAngriff2 speichert sie Anzahl der waagen, die Gruppe1 
// angreifen
   int attackBuilding;
/////////////////////////////////////////////////

    int xOld, yOld, rMouseW, building, pressedSec, mPressed;
    int navX, navY, nav2X, nav2Y;
// If building == -1 -> no building
    int typeOfCar, autoOn;
// if typeOfCar==-1->no car

    int maxKarteY, kBreite, kHoehe, maxKarteX, sciBuild;
    int geschw, moveKarteX, moveKarteY, selectCounter;
    int crossScrolling, crossRising;
    int selScrolling, selRising, steuerCars, steuerCars2;
    int steuerUsed, steuerUsed2, energieUsed, energieUsed2;
    QTimer *timer;
    QPainter p;
    QString mapInfoString;
    QString picPfad;
    const char *picPfad2;

//const QString picPfad="/dosd/panzer";

//in leiste wird die Art der linken Schaltflche gespeichert.
//bselected gibt an, welches Gebude gewhlt ist, -1= keines
//cidCounter = bezeichnet eine freie stelle im Array cars
//ist cidCounter= -1, so ist das Array voll besetzt.

    int karteX, karteY, bidCounter, leiste, bselected, cidCounter, az;
    int unselected, selRx1, selRy1, selRx2, selRy2;
// gibt an, ob Fahrzeuge selected sind
// 0 -> nein, 1 -> ja
//    int rand, karteXalt, karteYalt, mStartX, mStartY;
    int karteXalt, karteYalt, mStartX, mStartY;
    QRect r1;
    int baumKarte [karteRangeY+1][karteRangeX+1];
    int buildingKarte [karteRangeY+1][karteRangeX+1];
    int fogKarte [karteRangeY+1][karteRangeX+1];
//in fogKarte2 wird der gesamtStatus festgehalten (Ebtdeckungen)
    int fogKarte2 [karteRangeY+1][karteRangeX+1];
    int fogKarteSchwarz [karteRangeY+1][karteRangeX+1];

//LEGENDE FOGKARTE
//
//1 -> sichtbar
//2 -> schwarz
//3 -> grau

    QString infoString;
    QPixmap pan[41];
    QPixmap pan2[41];
    QPixmap pan1[41];
    QPixmap pan3[41];
    QPixmap pwasser[13];
    QPixmap shoots[5];
    QPixmap movRadar[10];
    QPixmap movSci[10];
    QPixmap movCan2[10];
    QPixmap movZen[10];
    QPixmap movSte[10];
    QPixmap movEn2[10];
    QPixmap pSchwarz, pGrau;
    QString text, text2;
    nextStepp *stepp, *stepp2;
    int addEnergie, addEnergie2, t;
    long energie, energie2;
    int selSicherC [maxCars];
    int selSicherB [maxBuildings];
//2 steht fr Gruppe 2
    
    typedef struct 
    {
      int id, selected, ortX, ortY, power;
      int gruppe, bWidth;
      QRect rBuilding;
      int health, building, shootX, shootY, shootFreq, shootVerlauf;
    } buildingType;

    typedef struct 
    {
        int EnergieGesamt1, EnergieGesamt2, killsCars, losesCars;
        int killsBuildings, losesBuildings, sieg;
    } winDatenType;

    winDatenType winDaten;

    buildingType buildings[maxBuildings];

    typedef struct
    {
      int karte[karteRangeY+1][karteRangeX+1];
      int fog  [karteRangeY+1][karteRangeX+1];
      int fog2 [karteRangeY+1][karteRangeX+1];
      int windowX, windowY;
    } kartetyp;
 
    kartetyp mKarte;

    typedef struct
    {
      int verlauf, gruppe;
      int health, power;// maxLength;
//////////////abgespeichert////////////////
      int wache, wacheX, wacheY;
/////////////////////////////////////////////////

//Fllt gerade kein Schuss, so sei Shootx, shooty =-1;

      int shootX, shootY, length, shootVerlauf, shootFreq, type;
      int jeepS3x, jeepS3y, jeepS1x, jeepS1y, jeepS2x, jeepS2y;
      QPixmap jeep;
      int selected, pic, stepps;
      int jeepX, jeepY;
      int destinationX, destinationY;
      QRect rJeep;
      QRect rJeep2;
    } car;
    car cars[maxCars];

public slots:
   void scrollKarteH (int x);
   void scrollKarteV (int y);
   void animate ();
   void buildZentrale ();
   void buildCarprod ();
   void buildCannon ();
   void buildCannon2 ();
   void buildSci ();
   void buildRadar ();
   void buildEnergie ();
   void buildEnergie2 ();
   void buildSteuer ();
   void buildPan1 ();
   void buildPan2 ();
   void buildPan3 ();
   void buildPan4 ();
   void unselectSlot ();
   void scrollKarteSlot(int x, int y);
   void autoChangedSlot (int num);
   void changeGradSlot(const char* grad);
   void changeGradSlotInt(int grad);

signals:
  void SbarHSlotInSignal(int value);
  void changeLeiste (QString name);
  void changeEnergie (int energie);
  void energieUsedSignal (int energie);
  void energieAdd (int energie);
  void controlersUsedSignal (int num);
  void controlersSignal (int num);
  void refreshMiniKarte (kartetyp Karte);
  void SbarVSlotInSignal(int value);
  void siegSignal (int gruppe, winDatenType winDaten);
  void saveGameSignal (QString fName);

protected:

};

#endif
