/*
###########################################################################
#                                                                         #
# File   :	sbarv.cpp                                                 #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/

#include "sbarv.h"

  sBarV::sBarV(QWidget *parent=0, const char *name=0)
           :QWidget (parent, name)
  {
    hoehe=200;
    breite=12;
    range=1040;
    scrollBarV = new QScrollBar( 0, range,          // range
                           1, 120,                       // line/page steps
                           0,                           // inital value
                           QScrollBar::Vertical,        // orientation
                           this, "scrollbar" );
    scrollBarV->setGeometry(0,0, breite, hoehe);
//    scrollBarV->setGeometry(0,0, 12, 120);
    connect( scrollBarV, SIGNAL(valueChanged(int)),
             this, SLOT (changeSbarVSlotOut(int)));
  }

void sBarV::changeSbarVSlotOut (int value)
  {
    emit sBarVSignal (value);
  }

void sBarV::resizeEvent (QResizeEvent *)
  {
    scrollBarV->setGeometry(0,0, breite, hoehe);
    scrollBarV->setRange(1,range);
  }

void sBarV::changeSbarVSlotIn (int value)
  {
    scrollBarV->setValue (value);
  }
