/*
###########################################################################
#                                                                         #
# File   :	stepp.cpp                                                 #
# Project:	PP - Prometheus Project                                   #
#                                                                         #
# Started:	02.04.98                                                  #
# Changed:	02.04.98                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Copyright (C) 1998 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################
*/
#include "stepp.h"

int nextStepp::findIterativDirect (int qX, int qY, int dX, int dY)
{
  int x=qX, y=qY; 
  int ende=0, first=0;
  while ( ((x!=dX)||(y!=dY))&&((ende==0)||(ende==2)) )
  {
    oldNextX=nextX;
    oldNextY=nextY;
    nextMoveLine (x,y,dX,dY);
    if (feld [nextX][nextY]==1)
    {
      x=nextX;
      y=nextY;
      feld [nextX][nextY]=3;
      if (first==0)
      {
        firstX=x;
        firstY=y;
        first=1;
        ende=2;
      }
    }
    else
// Es liegt etwas im direktem Weg:
    {
      if (ende==0)
        {ende=1;}
      else {ende=3;}
    }
  }
  return (ende);

//LEGENDE:
//
// 0 -> er ist angekommen und keinen Schrit gegangen
// 1 -> er ist keinen Schritt gegangen und nicht angekommen
// 2 -> er ist angekommen und einen schritt gegangen
// 3 -> er ist nicht angekommen, aber einen Schritt gegangen

}

void nextStepp::nextMoveLine(int x, int y, int x2, int y2)
{
  int d, dx, dy, ai, bi, xi, yi;

  if (x < x2) 
  { 
    xi = 1; 
    dx = x2 - x; 
  } 
  else 
  { 
    xi = - 1; 
    dx = x - x2; 
  } 
 
  if (y < y2)
  {
    yi = 1; 
    dy = y2 - y; 
  }
  else 
  { 
    yi = - 1; 
    dy = y - y2; 
  } 
 
  if (dx > dy)
  {
    ai = (dy - dx) * 2; 
    bi = dy * 2; 
    d  = bi - dx; 

      if (d >= 0)
      {
        y += yi; 
        d += ai; 
      } 
      else
      {
        d += bi;
      }
      x += xi;
      nextX=x;
      nextY=y;
  } 
  else 
  { 
    ai = (dx - dy) * 2; 
    bi = dx * 2; 
    d  = bi - dy; 
    {
      if (d >= 0)
      { 
        x += xi;
        d += ai;
      }
      else 
      {
        d += bi;
      }
      y += yi;
      nextX=x;
      nextY=y;
    }
  }
} 

nextStepp::nextStepp (QWidget *parent=0, const char *name=0):QWidget
(parent, name)
  {
    oldX=0;
    oldY=0;
  }
		      
// Return-Werte: 1 -> Ausgang gefunden

///////////////////////////////////////////////////////////////////////
// ACHTUNG: In dieser Funktion sind die x/y - Bezeichner vertauscht! //
///////////////////////////////////////////////////////////////////////

void nextStepp::suche (int y, int x, int qX, int qY, int dX, int dY)
  {
    if ((x==dY) && (y==dX))
    {
      found=1;      
    }
    feld [x][y]=2;
    if ((feld [x][y+1]==1)&&(found==0)&&(y<karteRangeY)) {
      suche (y+1, x, qX, qY, dX, dY);
    }
    if ((feld [x+1][y]==1)&&(found==0)&&(x<karteRangeX)) {
      suche (y, x+1, qX, qY, dX, dY);
    }
    if ((feld [x-1][y]==1)&&(found==0)&&(x>0)) {
      suche (y, x-1, qX, qY, dX, dY);
    }
    if ((feld [x][y-1]==1)&&(found==0)&&(y>0)) {
      suche (y-1, x, qX, qY, dX, dY);
    }
    if (found !=0)
    {
      feld [x][y]=3;
      if ((x!=qY)||(y!=qX))
      {
        oldX=y;
        oldY=x;
      }
    }
  }

///////////////////////////////////////////////////////////////////////
// ACHTUNG: In dieser Funktion sind die x/y - Bezeichner vertauscht! //
///////////////////////////////////////////////////////////////////////

int nextStepp::findIterativ (int qX, int qY, int dX, int dY)
{
  int x=qX;
  int y=qY;
  int ifound=0, gone=0, first=1;
  while (ifound==0)
  {
    if (y<dY)
    {
      if (feld [x][y+1]==1)
      {
        y+=1;
        gone=1;
        feld [x][y]=3;
      }
    }
    if ((y>dY)&&(gone==0))
    {
      if (feld [x][y-1]==1)
      {
        y-=1;
        gone=1;
        feld [x][y]=3;
      }
    }
    if ((x>dX)&&(gone==0))
    {
      if (feld [x-1][y]==1)
      {
        x-=1;
        gone=1;
        feld [x][y]=3;
      }
    }
    if ((x<dX)&&(gone==0))
    {
      if (feld [x+1][y]==1)
      {
        x+=1;
        gone=1;
        feld [x][y]=3;
      }
    }
    if (gone==0)
    {
      if ((x==dX)&&(y==dY))
        {ifound=1;}//gefunden
      else
        {ifound=2;}//nicht gefunden
    }
    if (first==1)
    {
       oldX=y;
       oldY=x;
       first=0;
    }
    gone=0;    
  }
  return ifound;
}

void nextStepp::findBest (int qX, int qY, int dX, int dY)
{
   feld=speicher;
   int aqX=qX, aqY=qY, adX=dX, adY=dY;
   found=0;
   if (findIterativDirect (qX, qY, dX, dY)==1)
// Der direckte Weg war versperrt und es wurde kein Schritt 
// zurckgelegt
   {
     found=0;
     feld=speicher;
     if (findIterativ (qX, qY, dX, dY)!=1)
     {
       feld=speicher;
       found=0;
       suche (qY, qX, qY, qX, dY, dX);
     }
  }
  else
  {
/*    if (aqX==adX)
      {oldX=aqX;}
    else
      {oldX=firstY;}
    if (aqY==adY)
      {oldY=aqY;}
    else
      {oldY=firstX;}*/
    if (aqX==adX)
      {oldY=aqX;}
    else
      {oldY=firstX;}
    if (aqY==adY)
      {oldX=aqY;}
    else
      {oldX=firstY;}
  }

   /*feld=speicher;
   found=0;
   feld=speicher;
   if (findIterativ (qX, qY, dX, dY)!=1)
   {
     feld=speicher;
     found=0;
    suche (qY, qX, qY, qX, dY, dX);
   }*/
}
